// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

class PanelDIS 
                extends         JDialog
 {


  public static final long serialVersionUID = 112;

  // Variables declaration - do not modify
  private javax.swing.JButton jButton1;
  public JTextField sQ2min;
  public JTextField sQ2max;
  public JTextField sXmin;
  public JTextField sXmax;
  public JTextField sYmin;
  public JTextField sYmax;
  public JTextField sWmin;
  public JTextField sWmax;
  private JPanel SETTINGmain;
  private JPanel SETTINGkinem;
  private JPanel contentPane;
   
  


 // DIS pannel  
  public PanelDIS()  {

   super( Global.mainFrame );
   setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
 
   contentPane = (JPanel)getContentPane();
   setTitle( "DIS cuts:");
   setSize(new Dimension(250, 250));
   contentPane.setPreferredSize(new Dimension(230, 245));
   
    SETTINGmain = new JPanel();
    SETTINGmain.setPreferredSize(new java.awt.Dimension(230, 240));
    SETTINGmain.setMinimumSize(new java.awt.Dimension(100, 100));
    contentPane.add(SETTINGmain);

        
    SETTINGkinem = new JPanel();
    SETTINGkinem.setPreferredSize(new java.awt.Dimension(230, 210));
    SETTINGkinem.setMinimumSize(new java.awt.Dimension(100, 100));
    SETTINGkinem.setBackground(new java.awt.Color(204, 204, 255));
    SETTINGmain.add(SETTINGkinem);
  
    sQ2min = new JTextField();
    sQ2min.setBackground(new java.awt.Color(252, 252, 252));
       sQ2min.setFont(SetEnv.FontBold);
       sQ2min.setPreferredSize(new java.awt.Dimension(100, 45));
       sQ2min.setMinimumSize(new java.awt.Dimension(50, 25));
       sQ2min.setHorizontalAlignment(JTextField.RIGHT);
       sQ2min.setText("0.0");
       sQ2min.setBorder(new TitledBorder(null,
                                   "Q2(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));

     sQ2min.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sQ2min.getText();  s1=s1.trim();
     SetIni.Q2min=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sQ2min.getText(); s2=s2.trim();
     SetIni.Q2min=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sQ2min.getText(); s3=s3.trim();
     SetIni.Q2min=Utility.GetDoubleError(s3);
     }  });



      sQ2max = new JTextField();
      sQ2max.setBackground(new java.awt.Color(252, 252, 252));
       sQ2max.setFont(SetEnv.FontBold);
       sQ2max.setPreferredSize(new java.awt.Dimension(100, 45));
       sQ2max.setMinimumSize(new java.awt.Dimension(50, 25));
       sQ2max.setHorizontalAlignment(JTextField.RIGHT);
       sQ2max.setText("1000000.0");
       sQ2max.setBorder(new TitledBorder(null,
                                   "Q2(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
     sQ2max.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sQ2max.getText();  s1=s1.trim();
     SetIni.Q2max=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sQ2max.getText(); s2=s2.trim();
     SetIni.Q2max=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sQ2max.getText(); s3=s3.trim();
     SetIni.Q2max=Utility.GetDoubleError(s3);
     }  });


  
      sXmin = new JTextField();
      sXmin.setBackground(new java.awt.Color(252, 252, 252));
       sXmin.setFont(SetEnv.FontBold);
       sXmin.setPreferredSize(new java.awt.Dimension(100, 45));
       sXmin.setMinimumSize(new java.awt.Dimension(50, 25));
       sXmin.setHorizontalAlignment(JTextField.RIGHT);
       sXmin.setText("0.0");
       sXmin.setBorder(new TitledBorder(null,
                                   "Xbj(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
 
    sXmin.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sXmin.getText();  s1=s1.trim();
     SetIni.Xmin=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sXmin.getText(); s2=s2.trim();
     SetIni.Xmin=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sXmin.getText(); s3=s3.trim();
     SetIni.Xmin=Utility.GetDoubleError(s3);
     }  });


     sXmax = new JTextField();
      sXmax.setBackground(new java.awt.Color(252, 252, 252));
       sXmax.setFont(SetEnv.FontBold);
       sXmax.setPreferredSize(new java.awt.Dimension(100, 45));
       sXmax.setMinimumSize(new java.awt.Dimension(50, 25));
       sXmax.setHorizontalAlignment(JTextField.RIGHT);
       sXmax.setText("1.0");
       sXmax.setBorder(new TitledBorder(null,
                                   "Xbj(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
        
     sXmax.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sXmax.getText();  s1=s1.trim();
     SetIni.Xmax=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sXmax.getText(); s2=s2.trim();
     SetIni.Xmax=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sXmax.getText(); s3=s3.trim();
     SetIni.Xmax=Utility.GetDoubleError(s3);
     }  });
       
       
      
      sYmin = new JTextField();
      sYmin.setBackground(new java.awt.Color(252, 252, 252));
       sYmin.setFont(SetEnv.FontBold);
       sYmin.setPreferredSize(new java.awt.Dimension(100, 45));
       sYmin.setMinimumSize(new java.awt.Dimension(50, 25));
       sYmin.setHorizontalAlignment(JTextField.RIGHT);
       sYmin.setText("0.0");
       sYmin.setBorder(new TitledBorder(null,
                                   "Y(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));

     sYmin.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sYmin.getText();  s1=s1.trim();
     SetIni.Ymin=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sYmin.getText(); s2=s2.trim();
     SetIni.Ymin=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sYmin.getText(); s3=s3.trim();
     SetIni.Ymin=Utility.GetDoubleError(s3);
     }  });


      sYmax = new JTextField();
      sYmax.setBackground(new java.awt.Color(252, 252, 252));
       sYmax.setFont(SetEnv.FontBold);
       sYmax.setPreferredSize(new java.awt.Dimension(100, 45));
       sYmax.setMinimumSize(new java.awt.Dimension(50, 25));
       sYmax.setHorizontalAlignment(JTextField.RIGHT);
       sYmax.setText("1.0");
       sYmax.setBorder(new TitledBorder(null,
                                   "Y(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));
     sYmax.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sYmax.getText();  s1=s1.trim();
     SetIni.Ymax=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sYmax.getText(); s2=s2.trim();
     SetIni.Ymax=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sYmax.getText(); s3=s3.trim();
     SetIni.Ymax=Utility.GetDoubleError(s3);
     }  });
 
      


      sWmin = new JTextField();
      sWmin.setBackground(new java.awt.Color(252, 252, 252));
       sWmin.setFont(SetEnv.FontBold);
       sWmin.setPreferredSize(new java.awt.Dimension(100, 45));
       sWmin.setMinimumSize(new java.awt.Dimension(50, 25));
       sWmin.setHorizontalAlignment(JTextField.RIGHT);
       sWmin.setText("0.0");
       sWmin.setBorder(new TitledBorder(null,
                                   "W(min)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));

     sWmin.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sWmin.getText();  s1=s1.trim();
     SetIni.Wmin=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sWmin.getText(); s2=s2.trim();
     SetIni.Wmin=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sWmin.getText(); s3=s3.trim();
     SetIni.Wmin=Utility.GetDoubleError(s3);
     }  });



      sWmax = new JTextField();
      sWmax.setBackground(new java.awt.Color(252, 252, 252));
       sWmax.setFont(SetEnv.FontBold);
       sWmax.setPreferredSize(new java.awt.Dimension(100, 45));
       sWmax.setMinimumSize(new java.awt.Dimension(50, 25));
       sWmax.setHorizontalAlignment(JTextField.RIGHT);
       sWmax.setText("10000.0");
       sWmax.setBorder(new TitledBorder(null,
                                   "W(max)",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));



     sWmax.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     String s1;  s1=sWmax.getText();  s1=s1.trim();
     SetIni.Wmax=Utility.GetDouble(s1);  }
     public void removeUpdate(DocumentEvent e) {
     String s2;  s2=sWmax.getText(); s2=s2.trim();
     SetIni.Wmax=Utility.GetDouble(s2);    }
     public void insertUpdate(DocumentEvent e) {
     String s3; s3=sWmax.getText(); s3=s3.trim();
     SetIni.Wmax=Utility.GetDoubleError(s3);
     }  });



 
  
        SETTINGkinem.add(sQ2min);   
        SETTINGkinem.add(sQ2max);   

        SETTINGkinem.add(sXmin);   
        SETTINGkinem.add(sXmax);   

        SETTINGkinem.add(sYmin);
        SETTINGkinem.add(sYmax);

        SETTINGkinem.add(sWmin);
        SETTINGkinem.add(sWmax);
 
        
        
        jButton1 = new javax.swing.JButton();
        jButton1.setText("Exit");
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setMaximumSize(new java.awt.Dimension(60, 25));
        jButton1.setPreferredSize(new java.awt.Dimension(70, 25));
        jButton1.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
         getContentPane().add(jButton1,java.awt.BorderLayout.SOUTH);
          
        
         jButton1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit DIS settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) { 
           SetIni.ShowStatus="Last action: Exit DIS window"; 
           setVisible(false); dispose();}
        }  });

        
        
        pack(); 
          
   
        }   


// update this pannel with new settings
   public void setPan()  {

     sQ2min.setText(Double.toString(SetIni.Q2min));
     sQ2max.setText(Double.toString(SetIni.Q2max));
     sXmin.setText(Double.toString(SetIni.Xmin));
     sXmax.setText(Double.toString(SetIni.Xmax));
     sYmin.setText(Double.toString(SetIni.Ymin));
     sYmax.setText(Double.toString(SetIni.Ymax));
     sWmin.setText(Double.toString(SetIni.Wmin));
     sWmax.setText(Double.toString(SetIni.Wmax));


     }



// create about
   public void setVisible() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(0.42*w),res.width),
                        Math.min((int)(0.7*h), res.height) );
    this.setSize(size);
    Util.rightWithin ( Global.mainFrame, this );

 //   Util.centreWithin( Global.mainFrame, this );
     this.setVisible(true);  

   }



// create about
   public void setInvisible() {
        setVisible(false);
   }






          
       

} // end class

