// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC.ui;

// MC settings
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;



 public class Tab3 extends JPanel {
  

  public static final long serialVersionUID = 103;
   
  public JComboBox particle1;
  public JComboBox particle2; 
  public JComboBox pdf1;
  public JComboBox pdf2;
  public JComboBox FStype;
  public JComboBox FSsys;
  public JComboBox FSjet;
  public JButton   jetSettings;
  public JButton   parSettings;
  public JButton   disSettings;
  public JButton   ThePeg;
  public JTextField energy1;
  public JTextField energy2;
  public JButton    b1; 
  public JPanel     SETTINGpanel;     
  
  public JButton   ntfiles; 
  public JButton   checkfiles;
  public JButton   infofiles;
  public JButton   ntview;
  public JComboBox nthowmany;
  public static String NTselect[] = {"single file","all files"};
  public JPanel    NTpanel;                    
  private PanelJets Pjet;
  private PanelParticles Pparticle;
  private PanelDIS Pdis;
  private JFileChooser fntup; 
  
    public Tab3() {
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50));    
    
      
    
    SETTINGpanel = new JPanel();
   //  SETTINGpanel.setBackground(new java.awt.Color(204, 204, 255));
    SETTINGpanel.setPreferredSize(new java.awt.Dimension(500, 250));
    SETTINGpanel.setMinimumSize(new java.awt.Dimension(40, 10));
    //SETTINGpanel.setVisible(true);
    this.add(SETTINGpanel);
    SETTINGpanel.setLayout(null);
 
    Pjet = new PanelJets(); // jet pannel  
    Pparticle = new PanelParticles(); // particle pannel 
    Pdis = new PanelDIS(); // dis pannel  



 
      
      particle1 = new JComboBox(SetIni.PIDname);
      particle1.setBounds(20,10,100,25);
      particle1.setFont(SetEnv.FontBold);
      particle1.setSelectedIndex(0);
      particle1.setPreferredSize(new java.awt.Dimension(100, 25));
      SETTINGpanel.add(particle1);

     particle1.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
    SetIni.IDparticle1=Utility.GetIDhep(nn);
    // T7.showSummary(nn,-1);
        disSettings.setVisible(false);
        if (Utility.iDIS() ==1 ) disSettings.setVisible(true);
        setMessage();
       } } );


 
      
      particle2 = new JComboBox(SetIni.PIDname);
      particle2.setBounds(120,10,100,25);
      particle2.setSelectedIndex(1);
      particle2.setFont(SetEnv.FontBold);
      particle2.setPreferredSize(new java.awt.Dimension(100, 25));
      SETTINGpanel.add(particle2);

    particle2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
       SetIni.IDparticle2=Utility.GetIDhep(nn);
    // T7.showSummary(-1,nn);
        disSettings.setVisible(false);
        if (Utility.iDIS() ==1 ) disSettings.setVisible(true);
        setMessage();
       } } );








 
      pdf1 = new JComboBox(SetIni.PDF);
      pdf1.setBounds(20,40,100,25);
      pdf1.setFont(SetEnv.FontBold);
      pdf1.setSelectedIndex(0);
      pdf1.setPreferredSize(new java.awt.Dimension(100, 25));
      SETTINGpanel.add(pdf1);

    pdf1.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
    SetIni.PDFparticle1= nn+1;
     } } );


      
      pdf2 = new JComboBox(SetIni.PDF);
      pdf2.setBounds(120,40,100,25);
      pdf2.setSelectedIndex(0);
      pdf2.setFont(SetEnv.FontBold);
      pdf2.setPreferredSize(new java.awt.Dimension(100, 25));
      SETTINGpanel.add(pdf2);

    pdf2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
    SetIni.PDFparticle2= nn+1;
     } } );

 
      energy1 = new JTextField();
      energy1.setFont(SetEnv.FontBold);
      energy1.setPreferredSize(new java.awt.Dimension(100, 45));
      energy1.setMinimumSize(new java.awt.Dimension(50, 25));
      energy1.setText("250.0");
      energy1.setBounds(20,70,100,40); 
      energy1.setBorder(new TitledBorder(null,
                                   "E1(GeV):",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));

     SETTINGpanel.add(energy1);
     energy1.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
      SetIni.Energy1=Utility.GetDouble(energy1.getText());
      setMessage();
    //  T7.showSummary(-1,-1);
      }
     public void removeUpdate(DocumentEvent e) {
      SetIni.Energy1=Utility.GetDouble(energy1.getText());
      setMessage();
    //  T7.showSummary(-1,-1);
      }
     public void insertUpdate(DocumentEvent e) {
      SetIni.Energy1=Utility.GetDoubleError(energy1.getText());
    //  T7.showSummary(-1,-1);
     setMessage();
     }  });





      energy2 = new JTextField();
      energy2.setFont(SetEnv.FontBold);
      energy2.setPreferredSize(new java.awt.Dimension(100, 45));
      energy2.setMinimumSize(new java.awt.Dimension(50, 25));
      energy2.setText("250.0");
      energy2.setBounds(120,70,100,40);
      energy2.setBorder(new TitledBorder(null,
                                   "E2(GeV):",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION,
                                     new java.awt.Font("Dialog", 0, 12)));


     SETTINGpanel.add(energy2);
    energy2.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
      SetIni.Energy2=Utility.GetDouble(energy2.getText());
    //  T7.showSummary(-1,-1);
        setMessage();
        }
     public void removeUpdate(DocumentEvent e) {
      SetIni.Energy2=Utility.GetDouble(energy2.getText());
    //  T7.showSummary(-1,-1); 
        setMessage();
        }
     public void insertUpdate(DocumentEvent e) {
      SetIni.Energy2=Utility.GetDoubleError(energy2.getText());
    //  T7.showSummary(-1,-1);
       setMessage();
      }  });











    // final state
      FStype = new JComboBox(SetIni.FS);
      FStype.setBounds(320,5,170,25);
      FStype.setSelectedIndex(0);
      FStype.setFont(SetEnv.FontBold);
      FStype.setSelectedIndex(0);
      FStype.setPreferredSize(new java.awt.Dimension(170, 25));
      SETTINGpanel.add(FStype);
// which HFS
    FStype.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
      SetIni.FStype= nn+1;
      setMessageFS();
     } } );

 
      //Frame 
      FSsys = new JComboBox(SetIni.MFrame);
      FSsys.setBounds(320,40,170,25);
      FSsys.setSelectedIndex(0);
      FSsys.setFont(SetEnv.FontBold);
      FSsys.setSelectedIndex(0);
      FSsys.setPreferredSize(new java.awt.Dimension(170, 25));
      SETTINGpanel.add(FSsys);   
   // which frame
    FSsys.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();
     SetIni.Frame= nn+1;
     } } );
      
                    
    // final state
      FSjet = new JComboBox(SetIni.JET);
      FSjet.setBounds(320,75,170,25);
      FSjet.setSelectedIndex(0);
      FSjet.setFont(SetEnv.FontBold);
      FSjet.setSelectedIndex(0);
      FSjet.setPreferredSize(new java.awt.Dimension(170, 25));
      SETTINGpanel.add(FSjet);    

    FSjet.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
    JComboBox combo = (JComboBox)e.getSource();
    int nn=combo.getSelectedIndex();

 // show jet pannel
    jetSettings.setVisible(false);
    parSettings.setVisible(true);
    SetIni.JetType=1;
    if (nn  > 0) {
                 jetSettings.setVisible(true);
                 parSettings.setVisible(false);
                 SetIni.JetType=2;
                 setMessageFS();
              // T7.showSummaryOut2(); // show summary
                 };

     } } );



  
     jetSettings = new JButton("Jet settings");
     jetSettings.setBounds(320,110,170,25);
     jetSettings.setToolTipText("To specify settings for jets, click here");
     jetSettings.setFont(SetEnv.FontBold);
     jetSettings.setPreferredSize(new java.awt.Dimension(170, 25));
     jetSettings.setVisible(false);
     SETTINGpanel.add(jetSettings);
// show jet settings
     jetSettings.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
           SetIni.ShowStatus="Last action: show jet settings";
           Pparticle.setInvisible(); 
           Pjet.setVisible();
           }  });


     parSettings = new JButton("Particle settings");
     parSettings.setBounds(320,110,170,25);
     parSettings.setToolTipText("To specify cuts on particles, click here");
     parSettings.setFont(SetEnv.FontBold);
     parSettings.setPreferredSize(new java.awt.Dimension(170, 25));
     parSettings.setVisible(true);
     SETTINGpanel.add(parSettings);
     parSettings.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
           SetIni.ShowStatus="Last action: show particle settings";
           Pjet.setInvisible();
           Pparticle.setVisible();
           }  });

     

     ThePeg = new JButton("ThePEG settings");
     ThePeg.setBounds(320,145,170,25);
     ThePeg.setToolTipText("To initialise ThePEG, click here. Not active: Under construction!");
     ThePeg.setFont(SetEnv.FontBold);
     ThePeg.setPreferredSize(new java.awt.Dimension(170, 25));
     ThePeg.setVisible(false);
     SETTINGpanel.add(ThePeg);
// start ThePEG set up
    ThePeg.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
         SetIni.ShowStatus="Last action: Start ThePeG setup";
//         SetupTheEG setup = new SetupTheEG("Setup TheEG", true);
          }  });


 
    b1 = new JButton("Steering card");
    b1.setToolTipText("To edit initial parameters, click here");
    b1.setBounds(35,115,170,25);  
    b1.setPreferredSize(new java.awt.Dimension(170, 25));
    b1.setActionCommand("disable");
    SETTINGpanel.add(b1);    
// show editor
     b1.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
          File f1= new File(SetIni.card[SetIni.MCtype]);
           SetIni.ShowStatus="Last action: Start steering card editor";
          if (!f1.exists()) {
            JOptionPane dialog1 = new JOptionPane();
            int ask=dialog1.showConfirmDialog(dialog1,
             "Create new "+SetIni.card[SetIni.MCtype]+" ?",
             "Question", JOptionPane.YES_NO_OPTION,
       JOptionPane.QUESTION_MESSAGE, null );
       if (ask == JOptionPane.YES_OPTION) {
       EditorCards s1 = new EditorCards(SetIni.card[SetIni.MCtype],"new"); s1.setVisible(true);
        };
       } else { EditorCards s1 = new EditorCards(SetIni.card[SetIni.MCtype],"old");
       s1.setVisible(true); }
       }  });




    disSettings= new JButton("DIS settings");
    disSettings.setToolTipText("To edit initial parameters, click here");
    disSettings.setBounds(35,150,170,25);
    disSettings.setPreferredSize(new java.awt.Dimension(170, 25));
    disSettings.setActionCommand("disable");
    disSettings.setVisible(false);
    SETTINGpanel.add(disSettings);
    disSettings.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
           SetIni.ShowStatus="Last action: show DIS settings";
           Pdis.setVisible();
           }  });

    
    
    // ntuple pannel
    NTpanel = new JPanel();
   // NTpanel.setBackground(new java.awt.Color(204, 204, 255));
    NTpanel.setPreferredSize(new java.awt.Dimension(150, 170));
    NTpanel.setMinimumSize(new java.awt.Dimension(40, 10));
    NTpanel.setVisible(false);
    this.add(NTpanel);
    
    
    ntfiles = new JButton("Files");
    ntfiles.setToolTipText("To select ntuples, click here");
    ntfiles.setPreferredSize(new java.awt.Dimension(130, 25));
    ntfiles.setActionCommand("disable");
    NTpanel.add(ntfiles); 
 // to select ntuples
    ntfiles.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    fntup = new JFileChooser(SetEnv.RUNDIR+"/proj");
    if (SetIni.MCtype == -1) {
      fntup.addChoosableFileFilter(new FilterNT1()); SetIni.NTwhat=1;}
    if (SetIni.MCtype == -2) {
      fntup.addChoosableFileFilter(new FilterNT2()); SetIni.NTwhat=2;}
          int returnVal = fntup.showOpenDialog(Tab3.this);
          if (returnVal == JFileChooser.APPROVE_OPTION) {
          File file = fntup.getSelectedFile();
          String sname=file.getAbsolutePath();
          SetIni.NTname=file.getName();
          // get length
          int ilen=sname.length()-SetIni.NTname.length();
          String spath=sname.substring(0,ilen);
          SetIni.NTdir=spath; // this is path to this file
      //System.out.println(SetIni.NTdir);
      // create
       String sh = "bash"; String cop = "-c";
       String s1="";
      if (SetIni.MCtype == -1)  s1=" trunmc ";
      if (SetIni.MCtype == -2)  s1=" thepevt ";
      String cmd = SetEnv.RUNDIR+"/bin/ntupview "+sname+s1+" > .runmc_ntuple.info &" ;
            String[] exe0 = new String[] {sh, cop, cmd};
       // create file
        try {
        Process p = Runtime.getRuntime().exec(exe0);
        } catch (Exception err) {  err.printStackTrace(); }
        // delete file
        File fff=new File(".runmc.tup");
        boolean bfff=fff.delete(); // remove file
       // put info about the file
      try {FileOutputStream pipentup = new  FileOutputStream (".runmc.tup");
     PrintStream pntup = new PrintStream(pipentup);
     pntup.println(SetIni.NTdir+SetIni.NTname); pipentup.close();} 
     catch (IOException e){
     System.out.println("RunMC ntuple pipe error: "+e); }
       }
    } } );


 
     nthowmany = new JComboBox(NTselect);
     nthowmany.setSelectedIndex(0);
     nthowmany.setFont(SetEnv.FontBold);
     nthowmany.setPreferredSize(new java.awt.Dimension(130, 25));
     NTpanel.add(nthowmany);
   
     nthowmany.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            JComboBox combo = (JComboBox)e.getSource();
            int jntuple  = combo.getSelectedIndex();
      // System.out.print(jntuple);
      // delete file
        File fff=new File(".runmc.tup");
        boolean bfff=fff.delete(); // remove file

       if ( jntuple == 0) { // select only one ntuple
       // put info about the file
       try {FileOutputStream pipentup = new  FileOutputStream (".runmc.tup");
       PrintStream pntup = new PrintStream(pipentup);
       pntup.print(SetIni.NTdir+SetIni.NTname); 
       pipentup.close();} catch (IOException eer){
       System.out.println("RunMC ntuple pipe error: "+eer); }
       SetIni.NTread=0;
        }
         if ( jntuple == 1) { // select all ntuples
         // put info about the file
          SetIni.NTread=1;
          String sh = "bash"; String cop = "-c";
          String sstype="";
          if (SetIni.NTwhat ==1) sstype="*.rtup";
          if (SetIni.NTwhat ==2) sstype="*.htup";
          String cmd = "ls -1 "+SetIni.NTdir+sstype+" > .runmc.tup &";
               String[] exe0 = new String[] {sh, cop, cmd};
               try { Process p = Runtime.getRuntime().exec(exe0);
               } catch (Exception err) {err.printStackTrace(); }
         }
    }  });
 


   
    checkfiles = new JButton("Check files");
    checkfiles.setToolTipText("To verify selected ntuples, click here");
    checkfiles.setPreferredSize(new java.awt.Dimension(130, 25));
    checkfiles.setActionCommand("disable");
    NTpanel.add(checkfiles);  
    checkfiles.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
           SetIni.ShowStatus="Last action: show selected files"; 
           NTviewer ntv = new NTviewer(".runmc.tup"); ntv.setVisible(true);
           }  });


    
    infofiles = new JButton("Info");
    infofiles.setToolTipText("To look at ntuple variables, click here");
    infofiles.setPreferredSize(new java.awt.Dimension(130, 25));
    infofiles.setActionCommand("disable");
    NTpanel.add(infofiles);  
    infofiles.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
             SetIni.ShowStatus="Last action: show variables in ntuples";
             NTviewer ntv = new NTviewer(".runmc_ntuple.info"); ntv.setVisible(true);
           }  });
  
  
  
     ntview = new JButton("ntule view");
     ntview.setToolTipText("To start ntuple viewer, click here");
     ntview.setPreferredSize(new java.awt.Dimension(130, 25));
     ntview.setActionCommand("disable");
     NTpanel.add(ntview); 
  // start ntuple viwer
     ntview.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(java.awt.event.ActionEvent evt) {
               SetIni.ShowStatus="Last action: show variables in ntuples";
               String sh = "bash"; String cop = "-c";
               String s1="$RUNMC/bin/ntupview "+SetIni.NTdir+SetIni.NTname;
               String s2="";
               if (SetIni.MCtype == -1)  s2=" trunmc ";
               if (SetIni.MCtype == -2)  s2=" thepevt ";
               String cmd =s1+s2+"ok &";
               String[] exe0 = new String[] {sh, cop, cmd};
               try {
               Process p = Runtime.getRuntime().exec(exe0);
               } catch (Exception err) {  err.printStackTrace(); }
           }  });
   
    
    
    
    
    } // end Tab3 
   
// for file chooser
     class FilterNT1 extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            return filename.endsWith(".rtup"); }
            public String getDescription() {
            return "*.rtup"; }  }

        // for file chooser
     class FilterNT2 extends javax.swing.filechooser.FileFilter {
        public boolean accept(File file) {
            String filename = file.getName();
            return filename.endsWith(".htup"); }
            public String getDescription() {
            return "*.htup"; }  }


// update this pannel with new settings
   public void setPan()  {

   energy1.setText(Double.toString(SetIni.Energy1));
   energy2.setText(Double.toString(SetIni.Energy2));
     // System.out.println(Utility.GetID(SetIni.IDparticle1));
   particle1.setSelectedIndex(Utility.GetID(SetIni.IDparticle1));
   particle2.setSelectedIndex(Utility.GetID(SetIni.IDparticle2));
   pdf1.setSelectedIndex(SetIni.PDFparticle1-1);
   pdf2.setSelectedIndex(SetIni.PDFparticle2-1);

   FSsys.setSelectedIndex(SetIni.Frame-1);
   FStype.setSelectedIndex(SetIni.FStype-1);

  // set visible for jets specific settings
     if (SetIni.JetType == 1) {
        jetSettings.setVisible(false);
        parSettings.setVisible(true);
     }

     if (SetIni.JetType != 1) {
        jetSettings.setVisible(true);
        parSettings.setVisible(false);
      }

     // set jets 
     if (SetIni.JetType == 1) FSjet.setSelectedIndex(0);
     if (SetIni.JetType >  1) FSjet.setSelectedIndex(1);

 // if DIS, show options
      disSettings.setVisible(false);
      if (Utility.iDIS() ==1 ) disSettings.setVisible(true);

     Pjet.setPan();
     Pparticle.setPan();
     Pdis.setPan();

   }




// update this pannel with new settings
     private void setMessage()  {

     // show summary
     int m1=Utility.GetID(SetIni.IDparticle1);
     int m2=Utility.GetID(SetIni.IDparticle2);

     String par1=SetIni.PIDname[m1];
     String par2=SetIni.PIDname[m2];
     String ssum1=par1+"("+Double.toString(SetIni.Energy1)+" GeV)";
     String ssum2=par2+"("+Double.toString(SetIni.Energy2)+" GeV)";
     SetIni.ShowInitState=ssum1+"    "+ssum2;  
//     Global.mainFrame.ShowInitialState(SetIni.ShowInitState); 
    } 


    private void setMessageFS()  { 
    String FSouts=SetIni.FS[SetIni.FStype-1];
    String Jetouts="none";
    if (SetIni.JetType == 1) Jetouts="none";
    if (SetIni.JetType == 2) Jetouts="Jade jets";
    if (SetIni.JetType == 3) Jetouts="Durham jets";
    if (SetIni.JetType == 4) Jetouts="Kt jets";
    SetIni.ShowFS=FSouts+";    jets: "+Jetouts;
//    Global.mainFrame.ShowFinalState(  SetIni.ShowFS );  
    }








   
 
    } // end main  class
