
       SUBROUTINE runmcarlo(IRUN, ierr)

C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003


      include "../mcarlo/inc/pythia62.inc"
      include "../mcarlo/inc/ariadne4.inc"
      include "../inc/hepevt_pythia62.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"

      real PI,proton 
      Parameter (PI=3.141592654, proton=0.938272)
      character*10 Pname1,Pname2

      Integer I, J, N, nev, IPOSI
      Real pbeam(4), sinv,ebeam(4)
      Integer IRUN, ierr,IPAR
      Save nev,sinv 


      goto (1000, 2000, 3000) IRUN
      return

*      IF (IRUN.eq.0) GOTO 100
*      IF (IRUN.eq.1) GOTO 200
*      IF (IRUN.eq.2) GOTO 300

 1000   CONTINUE 

*-take positron (default) 
       IPOSI=-11
       nev=0
       ierr=1
       xCross=0.
       eCross=0.
 
C assume particle 1 is proton
       CKIN(61)=rXbj(2)  ! min X
       CKIN(62)=rXbj(3)  ! max X
       CKIN(73)=rYbj(2)  ! min Y
       CKIN(74)=rYbj(3)  ! max Y
       CKIN(65)=rQ2(2)  ! min Q2
       CKIN(66)=rQ2(3)  ! max Q2
C photoproduction
       if (rQ2(2).le.1) then
       CKIN(77)=rW(2)   ! min W
       CKIN(78)=rW(3)   ! max W
       endif
C this is DIS
       if (rQ2(2).gt.1) then
       CKIN(39)=rW(2)*rW(2)   ! min W2
       CKIN(40)=rW(3)*rW(3)   ! max W2
       endif


* set PDF for first particle
      IF (abs(PID1).ge.2000) THEN
      PDFGUP(1)=4
      PDFSUP(1)=46
      MSTP(52)=2
         IF (PDF1.eq.2) THEN
         PDFGUP(1)=3
         PDFSUP(1)=72
         MSTP(52)=2
         ELSEIF (PDF1.eq.3) THEN
         PDFGUP(1)=5
         PDFSUP(1)=12
         MSTP(52)=2
         ENDIF
         MSTP(51)=1000*PDFGUP(1)+PDFSUP(1)
      ENDIF
 
* set PDF for second particle
      IF (abs(PID2).ge.2000) THEN
      PDFGUP(2)=4
      PDFSUP(2)=46
      MSTP(52)=2
         IF (PDF2.eq.2) THEN
         PDFGUP(2)=3
         PDFSUP(2)=72
         MSTP(52)=2
         ELSEIF (PDF2.eq.3) THEN
         PDFGUP(2)=5
         PDFSUP(2)=12
         MSTP(52)=2
         ENDIF
         MSTP(51)=1000*PDFGUP(1)+PDFSUP(1)
      ENDIF


          ebeam(1)=0.
          ebeam(2)=0.
          ebeam(3)=-1*ENER1
          ebeam(4)=ENER1
          pbeam(1)=0.
          pbeam(2)=0.
          pbeam(3)=ENER2
          pbeam(4)=ENER2

                    
* redefine initial lepton  
        IF (abs(PID1).le.14) THEN
             IPOSI=PID1
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER1
             ebeam(4)=ENER1
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER2
           pbeam(4)=ENER2
         ENDIF
 
       IF (abs(PID2).le.14) THEN
             IPOSI=PID2
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER2
             ebeam(4)=ENER2
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER1
           pbeam(4)=ENER1
         ENDIF

C...Initialize.
      P(1,1)=ebeam(1)
      P(1,2)=ebeam(2)
      P(1,3)=ebeam(3)
      P(2,1)=pbeam(1)
      P(2,2)=pbeam(2)
      P(2,3)=pbeam(3)
C this is for DIS
      sinv = 4.*ebeam(4)*pbeam(4) + proton**2

       Call GeTName(PID1,Pname1,0)
       Call GeTName(PID2,Pname2,0)

       write(6,*) "ARIADNE: Beam 1", PID1, " ", Pname1
       write(6,*) "ARIADNE: Beam 2", PID2, " ", Pname2

C set seed number
      MRPY(1)=RUNMCseed1+RUNMCseed2
      write(6,*) "ARIADNE: new seed for this run = ",MRPY(1)

********all GeTNamePHP(PID1,Pname1,0)
      IF ( ((abs(PID1).le.14.and.abs(PID2).ge.2000) .or. 
     +      (abs(PID2).le.14.and.abs(PID1).ge.2000)) .and.
     +      rQ2(2).lt.0.01) then 
            Call GeTName(PID1,Pname1,1)
            Call GeTName(PID2,Pname2,1)
      ELSE
           ! for e+e- 
           IF ( abs(PID1).le.14.and.abs(PID2).le.14 ) then
           MSEL=0 ! Choice of Z/gamma  process.
           MSUB(1)=1
           ENDIF 

       ENDIF 


C       ...Initialize Ariadne to run with JETSET
       CALL ARINIT('PYTHIA')

C maximum  namber of errors
       MSTA(10)=999999


C set parameters via cards
        Call RunMC_Steer("ariadne.cards")
        Call RunMCariadnesteer

C set user initialisation parameters
        Call setARIADNE4



C print ariadne parameters
        CALL ARPRDA

C pythia   
       CALL PYINIT('3MOM',Pname1,Pname2,0D0)
 
*- initialize PYTHIA
       write(6,*) '  Generate events with ------'
       write(6,*) '  at centere-of-mass energy ' , EECM
       write(6,*) '  MSEL ',  MSEL
       write(6,*) '  MSUB(1) ',  MSUB(1)
       write(6,*) ' '
       CALL PYGIVE('MSTP(11)=0')
       write(6,*) '  ISR photon radiation is off'
********************* end of e+e- etc mode ********************************

       write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

C...Call generate an event with LEPTO
        CALL PYEVNT

C...Apply the Dipole Cascade
      CALL AREXEC

        nev=nev+1


        Q2=PARI(105)
        W=PARI(11)
        PT=PARI(17)
        PQ=P(2,4)*P(4,4)-P(2,1)*P(4,1)-P(2,2)*P(4,2)-P(2,3)*P(4,3)
        XBJ=Q2/(2D0*PQ)
        Ybj=Q2/(s_inv*XBJ)


C copy kinematic varaibles
        ierr=0        
        rQ2(1)=Q2
        rXbj(1)=XBJ
        rYbj(1)=YBJ 
        rW(1)=W
          
C.. convert from JETSET common
        CALL PYHEPC(1)
C...Call a user supplied analysis routine
        if (nev.le.5)  CALL PYLIST(1) 


 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

C...Final statistics
      CALL PYSTAT(1)

      xCross=1E09*XSEC(0,3)
      eCross=0.
      write(6,*) "RUNMC-ARIADNE4: total cross section is (pb): ", xCross
      write(6,*) 'RUNMC-ARIADNE4: ALL done!'


      RETURN      
      END  



**************************************************

       Subroutine GeTName(ID, NameP, imod)

      INTEGER imod,ID
      Character* 10 NameP 

      NameP="undefined" 

      IF (ID.eq.11)   NameP="e-"
      IF (ID.eq.-11)  NameP="e+" 
      IF (ID.eq.13)   NameP="mu-"
      IF (ID.eq.-13)  NameP="mu+"
      IF (ID.eq.15)   NameP="tau-"
      IF (ID.eq.-15)  NameP="tau+"
      IF (ID.eq.22)   NameP="gamma"
      IF (ID.eq.2112) NameP="n0"
      IF (ID.eq.-2112) NameP="nbar0" 
      IF (ID.eq.2212)  NameP="p+"
      IF (ID.eq.-2212) NameP="pbar-"
 
 
      IF (imod.eq.1) THEN ! for PHP
       IF (ID.eq.11)   NameP="gamma/e-"
       IF (ID.eq.-11)  NameP="gamma/e+"
       IF (ID.eq.13)   NameP="gamma/mu-"
       IF (ID.eq.-13)  NameP="gamma/mu+"
       IF (ID.eq.15)   NameP="gamma/tau-"
       IF (ID.eq.-15)  NameP="gamma/tau+"
       IF (ID.eq.22)   NameP="gamma"
       IF (ID.eq.2112) NameP="n0"
       IF (ID.eq.-2112) NameP="nbar0"
       IF (ID.eq.2212)  NameP="p+"
       IF (ID.eq.-2212) NameP="pbar-"
      ENDIF
 
      END








 
