
       SUBROUTINE runmcarlo(IRUN, ierr)

C run HERWIG 6.5
C
C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003

      INCLUDE 'src/HERWIG65.INC'
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"
      INTEGER iEP, N
      EXTERNAL HWUDAT

      Real RENER1, RENER2
      INTEGER JPID2,JPID1,JPDF1,JPDF2

      Real Q2,W,Y,X 
      Integer I, J, nev, IPOSI
      Integer IRUN,ierr,IPAR
      Character* 10 NameP
      Save iEP,nev,IPOSI 

      goto (1000, 2000, 3000) IRUN
      return

 1000   CONTINUE 


      write(6,*) "RUNMC: HERWIG INITIALISATION -----------------------" 


*-take positron (default) 
       nev=0
       ierr=1
       xCross=0.
       eCross=0.

C maximum number of events
         MAXEV=300000000


C  find out - is this DIS mode ?
        iEP=0
        if( (abs(PID1).le.17) .and. (abs(PID2).gt.2000) ) iEP=1
        if( (abs(PID2).le.17) .and. (abs(PID1).gt.2000) ) iEP=1
C E+E-
        if( (abs(PID1).le.17) .and. (abs(PID2).lt.17) ) iEP=2
C ppbar
        if( (abs(PID1).ge.2000) .and. (abs(PID2).gt.2000) ) iEP=3


* set initial particles
* HERWIG do not like P in +Z, so inverse it for DIS 
        IF ( (abs(PID1).ge.2000) .and. (abs(PID2).le.17) ) THEN
        JPID2=PID1
        JPID1=PID2
        RENER1=ENER2
        RENER2=ENER1
        JPDF1=PDF2
        JPDF2=PDF1

        PID1=JPID1
        PID2=JPID2
        ENER1=RENER1
        ENER2=RENER2
        PDF1=JPDF1
        PDF2=JPDF2
        ENDIF




** set ep collisions  =====================================
      IF (iEP.eq.1) then  
              IF (rQ2(2).lt.1.0)  IPROC=19130 ! direct photoproduction
              IF (rQ2(2).ge.1.0)  IPROC=19000 ! DIS 
*   some possibilities for IPROC:
*    19000  D.I.S. NC
*    19010  D.I.S. CC
*    19130  Direct Photoproduction
*    19104  c-cbar production in Boson-Gluon Fusion
*    19105  b-bar      "               "
*    19107  J/psi  photon-gluon fusion
*    11500  Resolved Photoproduction
*    11704  charm production in Resolved Photon
*    11705  beauty    "                "
*    11800  resolved prompt Photon + Jet production
*    15300  direct   prompt Photon + Jet production
*    NOTE : to ADD the S.U.E. subtract 10,000
*    ====   e.g. for Resolved Photoproduction IPROC=1500
*=====================================================================
        ENDIF
             

* E+E- collisions =============================================
       IF ( iEP .eq. 2 ) THEN  
        IPROC=100    ! for all quarks
* some other possibility
*        IPROC=106   ! for top quarks
*        IPROC=200   ! for W+W-
        ENDIF  
*===============================================================


** PP collisions ================================================
       IF ( iEP.eq.3 ) THEN
        IPROC=1500    ! for all quarks
        ENDIF
* ================================================================


** gamma gamma  collisions ================================================
       IF ( abs(PID1).eq.22.and.abs(PID2).eq.22) THEN
        IPROC=6000    ! for all quarks
        ENDIF
* ================================================================

C   Maximum number of errors
       MAXER=9999990

C---TIME (SEC) NEEDED TO TERMINATE GRACEFULLY
       TLOUT=40.

C PRINTOUT OPTION
        IPRINT=1
        MAXPR=3

 
        Call GeTName(PID1, NameP)
        PART1=NameP
        Call GeTName(PID2, NameP)
        PART2=NameP 
                    
        PBEAM1=ENER1
        PBEAM2=ENER2

C---INITIALISE OTHER COMMON BLOCKS
        CALL HWIGIN

        Q2MIN=rQ2(2)  ! min Q2
        Q2MAX=rQ2(3)  ! max Q2
        Q2WWMN=0.
        Q2WWMX=1.
        YBMIN=rYbj(2)
        YBMAX=rYbj(3)
        YWWMIN=rYbj(2)
        YWWMAX=rYbj(3)
        IFLMIN=1
        IFLMAX=5
        WHMIN=rW(2)   ! min W

C not decay after 1000 mm
      MAXDKL=.TRUE.
      IOPDKL=2    ! sphere
      DXRSPH=1000.
      write(6,*)DXRSPH,'mm maximum distance a decay is allowed'
      
** take seeds from RUNMC
      NRN(1)=RUNMCseed1
      NRN(2)=RUNMCseed2 
      write(6,*) "HERWIG uses for this run the following seeds =", 
     +  RUNMCseed1, RUNMCseed2 


       if (abs(PID1).eq.22) then  
* set photon structure function
       MODPDF(1)=11
       AUTPDF(1)='SaSph'
       endif
       if (abs(PID2).eq.22) then
* set photon structure function
       MODPDF(2)=11
       AUTPDF(2)='SaSph'
       endif
 
* set proton structure function
        IF (abs(PID1).ge.2000) THEN
          MODPDF(1)=46
          AUTPDF(1)='CTEQ'
          IF (PDF1.eq.2) THEN
          MODPDF(1)=72
          AUTPDF(1)='MRS'
          ELSEIF (PDF1.eq.3) THEN
          MODPDF(1)=12
          AUTPDF(1)='GRV'
         ENDIF
        ENDIF
* second particle
* set proton structure function
        IF (abs(PID2).ge.2000) THEN
          MODPDF(2)=46
          AUTPDF(2)='CTEQ'
          IF (PDF2.eq.2) THEN
          MODPDF(2)=72
          AUTPDF(2)='MRS'
          ELSEIF (PDF2.eq.3) THEN
          MODPDF(2)=12
          AUTPDF(2)='GRV'
         ENDIF
        ENDIF
 
        write(6,*) "PID1=",PID1, "  PDF=",AUTPDF(1)
        write(6,*) "PID2=",PID2, "  PDF=",AUTPDF(2)



C set structure functins
C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
      PTMIN=3. 
      IF (iEP.eq.3) PTMIN=30.

C set parameters via cards
       Call RunMC_Steer("herwig6.cards")
       Call RUNMCherwigsteer      

C set user initialisation
       Call setHERWIG65


C---COMPUTE PARAMETER-DEPENDENT CONSTANTS
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
C      CALL HWUSTA('PI0     ')
C---USER'S INITIAL CALCULATIONS
      CALL HWABEG
C---INITIALISE ELEMENTARY PROCESS
      CALL HWEINI


       write(6,*) ' FINISH INITIALIZATION'

       RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

      IERROR=0
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      CALL HWANAL
      IF (IERROR.NE.0) THEN 
       NHEP=-1 
       GOTO 9999
      ENDIF

      nev=nev+1
      ierr=0

** inverse, to get the  
       if (iEP.eq.1) then 
        DO I=1,NHEP
        PHEP(2,I)=-PHEP(2,I)
        PHEP(3,I)=-PHEP(3,I)
        ENDDO  
       endif


      IF (iEP.ne.2) THEN ! not E+E- 
        CALL GETKIN(Q2,X,Y,W) ! get kinematics
C copy kinematic varaibles
        rQ2(1)=Q2
        rXbj(1)=X
        rYbj(1)=Y 
        rW(1)=W
       ENDIF
   

 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE


C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN
C---USER'S TERMINAL CALCULATIONS
      CALL HWAEND


      xCross=1000.*AVWGT
      eCross=0. 
      write(6,*)"RUNMC-HERWIG: Cross section in (pb): ", xCross
      write(6,*)"RUNMC-HERWIG: ALL done!"

      RETURN      
      END  



C----------------------------------------------------------------------
      SUBROUTINE HWABEG
C     USER'S ROUTINE FOR INITIALIZATION
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWAEND
C     USER'S ROUTINE FOR TERMINAL CALCULATIONS, HISTOGRAM OUTPUT, ETC
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWANAL
C     USER'S ROUTINE TO ANALYSE DATA FROM EVENT
C----------------------------------------------------------------------
      END
C------------------


**************************************************
* get name of particle for HERWIG
      Subroutine GeTName(ID, NameP)

      INTEGER imod,ID
      Character* 10 NameP

      NameP="undefined"

      IF (ID.eq.11)   NameP="E-"
      IF (ID.eq.-11)  NameP="E+"
      IF (ID.eq.13)   NameP="MU-"
      IF (ID.eq.-13)  NameP="MU+"
      IF (ID.eq.15)   NameP="undefined"
      IF (ID.eq.-15)  NameP="undefined"
      IF (ID.eq.22)   NameP="GAMMA"
      IF (ID.eq.2112) NameP="N"
      IF (ID.eq.-2112) NameP="NBAR"
      IF (ID.eq.2212)  NameP="P"
      IF (ID.eq.-2212) NameP="PBAR"


      RETURN
      END 



*************************************************
* get kinematics

        SUBROUTINE GETKIN(Q2,XBJ,YBJ,W)

        INCLUDE 'src/HERWIG65.INC'
        REAL Q2,PQ,PK,XBJ,YBJ,W
        Real  PP(4),QQ(4)
        real  sinv,MPROTON
        PARAMETER (MPROTON=0.938272)  
        Integer M, I
        Save   PP


         XBJ=0.
         YBJ=0.
         Q2 =0.
         W  =0.

* get proton beam 
        DO I=1,2
        IF (abs(IDHEP(I)).ge.2000) THEN  
            DO M=1,4
            PP(M)=PHEP(M,I)
           ENDDO
        ENDIF 
        ENDDO
        sinv = 4.*PHEP(4,1)*PHEP(4,2) + MPROTON**2 
        Q2=0. 

* get gamma/Z boson 
       DO M=3,NHEP   
        IF (abs(IDHEP(M)).le.24.and.abs(IDHEP(M)).ge.22) THEN
        DO I=1,4
          QQ(I)=PHEP(I,M)
          Q2=PHEP(5,M)**2 
        ENDDO
        GOTO 8282
       ENDIF
       ENDDO
 8282  CONTINUE 


* Other kinematical variables
         Pq=PP(4)*QQ(4) - PP(3)*QQ(3)  
         XBJ=Q2/2./Pq
         YBJ=Q2/(XBJ*sinv)
         W=2.*Pq-Q2+MPROTON**2
         IF (W.GT.0.) THEN
           W=SQRT(W)
         ELSE
           W=MPROTON
         ENDIF

      RETURN
      END
