CDECK  ID>, HWUFNE.
*CMZ :-        -16/10/93  12.42.15  by  Mike Seymour
*-- Author :    Mike Seymour
C-----------------------------------------------------------------------
      SUBROUTINE HWUFNE
C-----------------------------------------------------------------------
C     FINALISES THE EVENT BY UNDOING THE LORENTZ BOOST IF THERE WAS ONE,
C     CHECKING FOR ERRORS, AND PRINTING
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IHEP
      LOGICAL CALLED
      COMMON/HWDBUG/CALLED
      CALLED=.TRUE.
C---UNBOOST EVENT RECORD IF NECESSARY
      CALL HWUBST(0)
C---CHECK FOR NEGATIVE ENERGY PARTICLES (REMNANT BUG?)
      DO IHEP=1,NHEP
         IF (ISTHEP(IHEP).EQ.1.AND.PHEP(4,IHEP).LT.ZERO)
     &       CALL HWWARN('HWUFNE',100,*99)
      ENDDO
 99   CONTINUE
C---CHECK FOR FATAL ERROR
      IF (IERROR.NE.0) THEN
        IF (IERROR.GT.0) THEN
          NUMER=NUMER+1
        ELSE
          NUMERU=NUMERU+1
        ENDIF
        IF (NUMER.GT.MAXER) CALL HWWARN('HWUFNE',300,*999)
        NEVHEP=NEVHEP-1
        IF (NEGWTS.AND.EVWGT.LT.ZERO) NNEGEV=NNEGEV-1
C---PRINT FIRST MAXPR EVENTS
      ELSEIF (NEVHEP.LE.MAXPR) THEN
        CALL HWUEPR
      END IF
  999 END
CDECK  ID>, HWUGAU.
*CMZ :-        -26/04/91  11.11.56  by  Bryan Webber
*-- Author :    Adapted by Bryan Webber
C-----------------------------------------------------------------------
      FUNCTION HWUGAU(F,A,B,EPS)
C-----------------------------------------------------------------------
C     ADAPTIVE GAUSSIAN INTEGRATION OF FUNCTION F
C     IN INTERVAL (A,B) WITH PRECISION EPS
C     (MODIFIED CERN LIBRARY ROUTINE GAUSS)
C-----------------------------------------------------------------------
      DOUBLE PRECISION HWUGAU,F,A,B,EPS,CONST,AA,BB,C1,C2,S8,U,S16,
     & W(12),X(12),ZERO
      INTEGER I
      EXTERNAL F
      PARAMETER (ZERO=0.0D0)
      DATA W/.1012285363D0,.2223810345D0,.3137066459D0,
     &       .3626837834D0,.0271524594D0,.0622535239D0,
     &       .0951585117D0,.1246289713D0,.1495959888D0,
     &       .1691565194D0,.1826034150D0,.1894506105D0/
      DATA X/.9602898565D0,.7966664774D0,.5255324099D0,
     &       .1834346425D0,.9894009350D0,.9445750231D0,
     &       .8656312024D0,.7554044084D0,.6178762444D0,
     &       .4580167777D0,.2816035508D0,.0950125098D0/
      HWUGAU=0.
      IF (A.EQ.B) RETURN
      CONST=.005/ABS(B-A)
      BB=A
    1 AA=BB
      BB=B
    2    C1=0.5*(BB+AA)
         C2=0.5*(BB-AA)
         S8=0.
         DO 3 I=1,4
            U=C2*X(I)
            S8=S8+W(I)*(F(C1+U)+F(C1-U))
    3    CONTINUE
         S8=C2*S8
         S16=0.
         DO 4 I=5,12
            U=C2*X(I)
            S16=S16+W(I)*(F(C1+U)+F(C1-U))
    4    CONTINUE
         S16=C2*S16
         IF (ABS(S16-S8).LE.EPS*(1.+ABS(S16))) GOTO 5
         BB=C1
         IF (CONST*ABS(C2).NE.ZERO) GOTO 2
C---TOO HIGH ACCURACY REQUESTED
         CALL HWWARN('HWUGAU',500,*999)
    5 HWUGAU=HWUGAU+S16
      IF (BB.NE.B) GOTO 1
  999 END
CDECK  ID>, HWUIDT.
*CMZ :-        -26/04/91  10.18.58  by  Bryan Webber
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWUIDT(IOPT,IPDG,IWIG,NWIG)
C-----------------------------------------------------------------------
C     TRANSLATES PARTICLE IDENTIFIERS:
C     IPDG = PARTICLE DATA GROUP CODE
C     IWIG = HERWIG IDENTITY CODE
C     NWIG = HERWIG CHARACTER*8 NAME
C
C     IOPT= 1 GIVEN IPDG, RETURNS IWIG AND NWIG
C     IOPT= 2 GIVEN IWIG, RETURNS IPDG AND NWIG
C     IOPT= 3 GIVEN NWIG, RETURNS IPDG AND IWIG
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER IOPT,IPDG,IWIG,I
      CHARACTER*8 NWIG
      IF (IOPT.EQ.1) THEN
        DO 10 I=0,NRES
        IF (IDPDG(I).EQ.IPDG) THEN
          IWIG=I
          NWIG=RNAME(I)
          RETURN
        ENDIF
  10    CONTINUE
        WRITE(6,20) IPDG
  20    FORMAT(1X,'Particle not recognised, PDG code: ',I8)
        IWIG=20
        NWIG=RNAME(20)
        CALL HWWARN('HWUIDT',101,*999)
      ELSEIF (IOPT.EQ.2) THEN
        IF (IWIG.LT.0.OR.IWIG.GT.NRES) THEN
          WRITE(6,30) IWIG
  30      FORMAT(1X,'Particle not recognised, HERWIG code: ',I3)
          IPDG=0
          NWIG=RNAME(20)
          CALL HWWARN('HWUIDT',102,*999)
        ELSE
          IPDG=IDPDG(IWIG)
          NWIG=RNAME(IWIG)
          RETURN
        ENDIF
      ELSEIF (IOPT.EQ.3) THEN
        DO 40 I=0,NRES
        IF (RNAME(I).EQ.NWIG) THEN
          IWIG=I
          IPDG=IDPDG(I)
          RETURN
        ENDIF
  40    CONTINUE
        WRITE(6,50) NWIG
  50    FORMAT(1X,'Particle not recognised, HERWIG name: ',A8)
        IWIG=20
        IPDG=0
        CALL HWWARN('HWUIDT',103,*999)
      ELSE
        CALL HWWARN('HWUIDT',404,*999)
      ENDIF
  999 END
CDECK  ID>, HWUINC.
*CMZ :-        -12/10/01  09.56.07  by  Peter Richardson
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWUINC
C-----------------------------------------------------------------------
C     COMPUTES CONSTANTS AND LOOKUP TABLES
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWBVMC,HWUALF,HWUPCM,XMIN,XMAX,XPOW,QR,DQKWT,
     & UQKWT,SQKWT,DIQWT,QMAX,PMAX,PTLIM,ETLIM,PGS,PTELM,X,QSCA,UPV,DNV,
     & USEA,DSEA,STR,CHM,BTM,TOP,GLU,VAL(20),CLMXPW,RCLPOW,TEST,RPM(2)
      INTEGER ISTOP,I,J,IQK,IDB,IDT,ISET,IOP1,IOP2,IP2,ID,IH,IV
      INTEGER LPROC,KPROC
      INTEGER IS,IP(3),IQ
      COMMON/SQSQH/JHIGGS,ILBL,JH,IF1MIN,IF1MAX,IF2MIN,IF2MAX
      INTEGER      JHIGGS,ILBL,JH,IF1MIN,IF1MAX,IF2MIN,IF2MAX
      INTEGER ISQ1,ISQ2
      INTEGER IHLP,JHLP,KHLP,ISIGN,ITMP(8)
      DATA ITMP/0,12,-12,0,0,12,-12,0/
      LOGICAL FIRST,FSTPDF
      CHARACTER*20 PARM(20)
      EXTERNAL HWBVMC,HWUALF,HWUPCM
      COMMON/HWRPIN/XMIN,XMAX,XPOW,FIRST
      COMMON/W50516/FSTPDF
C--read in the information frmo the Les Houches common block if needed
      IF(IPROC.LE.0) CALL HWIGUP
C---MSSM Higgs processes: additional IDs to distinguish from SM-like ones.
      IMSSM=0
      IHIGGS=0
C---Sets even parity of Higgs bosons (in the coupling to fermions) as default.
      PARITY=1
C...define parity of Neutral MSSM Higgses.
      IP(1)=+1
      IP(2)=+1
      IP(3)=-1
C---IPRO=9,11 (lepton-lepton); 31...38 (hadron-hadron) MSSM Higgs production.
      LPROC=MOD(IPROC,10000)
      IF((LPROC.LT.3100).OR.(LPROC.GE.3900))THEN
C...add here MSSM Higgs processes in lepton-lepton collisions.
        IF((LPROC/100.NE.9).AND.(LPROC/100.NE.11))GOTO 666
      END IF
C-----------------------------------------------------------------------
C     HARD 2 LEPTON/PARTON -> HIGGS + X PROCESSES IN MSSM
C     IH = 1   MSSM h^0     IV = 0 SM W+/-     IQ = 1,3,5 d,s,b-quark
C        = 2   MSSM H^0        = 1 SM Z             2,4,6 u,c,t-quark
C        = 3   MSSM A^0                        ID = IQ, IL
C        = 4/5 MSSM H^+/-                      IL = 1,2,3 e,mu,tau-lepton
C-----------------------------------------------------------------------
C...leptonic processes.
      IF(LPROC/100.EQ.9)THEN
        IF(LPROC.EQ.955)THEN
          IMSSM=-1
          IHIGGS=206-201
        ELSE IF(LPROC.EQ.965)THEN
          IHIGGS=203-201
          IMSSM=-1
        ELSE IF(LPROC.EQ.975)THEN
          IHIGGS=204-201
          IMSSM=-1
        ELSE IF((LPROC.EQ.910).OR.(LPROC.EQ.920).OR.
     &          (LPROC.EQ.960).OR.(LPROC.EQ.970))THEN
          KPROC=MIN(951,LPROC)
          IV=MAX(KPROC-950,0)
          IF((IV.LT.0).OR.(IV.GT.1))CALL HWWARN('HWUINC',627,*999)
          IH=LPROC/10-90-5*IV
          IF((IH.LE.0).OR.(IH.GT.2))CALL HWWARN('HWUINC',626,*999)
          IF(LPROC.LE.920)IMSSM=LPROC-400
          IF(LPROC.GE.960)IMSSM=LPROC-300
C...assign enhancement for MSSM Higgs-VV couplings, V->W,Z-gauge bosons.
          DO 545 I=10,10
            ENHANC(I  )=GHWWSS(IH)
            ENHANC(I+1)=GHZZSS(IH)
 545      CONTINUE
          IF(IH.EQ.1)IHIGGS=203-201
          IF(IH.EQ.2)IHIGGS=204-201
          IF(IH.EQ.3)IHIGGS=205-201
        ELSE
          CALL HWWARN('HWUINC',625,*999)
        END IF
      ELSE IF(LPROC/100.EQ.11)THEN
        IMSSM=-1
        IF(LPROC.GE.1140)THEN
          IHIGGS=207-201
          PARITY=1
          GOTO 548
        END IF
        IF(LPROC.LT.1140)IH=3
        IF(LPROC.LT.1130)IH=2
        IF(LPROC.LT.1120)IH=1
        IF((IH.LE.0).OR.(IH.GT.3))CALL HWWARN('HWUINC',624,*999)
        IQ=LPROC-1100-10*IH
        IF((IQ.LE.0).OR.(IQ.GT.9))CALL HWWARN('HWUINC',623,*999)
C...assign Neutral MSSM Higgs parity.
        PARITY=IP(IH)
C...assign enhancement for MSSM Higgs-QQ couplings, Q->U,D-type quarks.
        DO 546 I=1,5,2
          ENHANC(I  )=GHDDSS(IH)
          ENHANC(I+1)=GHUUSS(IH)
 546    CONTINUE
C...assign enhancement for MSSM Higgs-LL couplings, L->D-type leptons.
        ENHANC(7)=GHDDSS(IH)
        ENHANC(8)=GHDDSS(IH)
        ENHANC(9)=GHDDSS(IH)
C...assign enhancement for MSSM Higgs-VV couplings, V->W,Z-gauge bosons.
        DO 547 I=10,10
          ENHANC(I  )=GHWWSS(IH)
          ENHANC(I+1)=GHZZSS(IH)
 547    CONTINUE
        IF(IH.EQ.1)IHIGGS=203-201
        IF(IH.EQ.2)IHIGGS=204-201
        IF(IH.EQ.3)IHIGGS=205-201
 548    CONTINUE
C...hadronic processes.
      ELSE IF((LPROC/100.EQ.31).OR.(LPROC/100.EQ.32))THEN
        IF(LPROC/100.EQ.31)THEN
          IF((LPROC.LE.3109).OR.
     &      ((LPROC.GE.3119).AND.(LPROC.LE.3139)).OR.
     &      ((LPROC.GE.3149).AND.(LPROC.LE.3169)).OR.
     &       (LPROC.GE.3179))CALL HWWARN('HWUINC',622,*999)
          IMSSM=-1
          IF(LPROC/100-LPROC/10*10.LE.4)IHIGGS=5
          IF(LPROC/100-LPROC/10*10.GE.5)IHIGGS=6
        ELSE IF(LPROC/100.EQ.32)THEN
          IF(LPROC.LE.3209)CALL HWWARN('HWUINC',621,*999)
          IF(LPROC.EQ.3219)CALL HWWARN('HWUINC',620,*999)
          IF(LPROC.EQ.3229)CALL HWWARN('HWUINC',619,*999)
          IF(LPROC.EQ.3239)CALL HWWARN('HWUINC',618,*999)
          IF(LPROC.EQ.3249)CALL HWWARN('HWUINC',617,*999)
          IF(LPROC.EQ.3259)CALL HWWARN('HWUINC',616,*999)
          IF(LPROC.EQ.3269)CALL HWWARN('HWUINC',615,*999)
          IF(LPROC.EQ.3279)CALL HWWARN('HWUINC',614,*999)
          IF(LPROC.EQ.3289)CALL HWWARN('HWUINC',613,*999)
          IF(LPROC.GE.3299)CALL HWWARN('HWUINC',612,*999)
          IMSSM=-1
          IF(LPROC.LT.3300)IHIGGS=4
          IF(LPROC.LT.3290)IHIGGS=3
          IF(LPROC.LT.3280)IHIGGS=2
          IF(LPROC.LT.3270)IHIGGS=4
          IF(LPROC.LT.3260)IHIGGS=3
          IF(LPROC.LT.3250)IHIGGS=2
          IF(LPROC.LT.3240)IHIGGS=4
          IF(LPROC.LT.3230)IHIGGS=3
          IF(LPROC.LT.3220)IHIGGS=2
        END IF
C...assign squarks/Higgs-flavours.
        IF(LPROC/100.EQ.31)JHIGGS=1
        IF(LPROC/100.EQ.32)JHIGGS=IHIGGS-1
        IF(LPROC/100.EQ.31)ILBL=3100
        IF(LPROC/100.EQ.32)ILBL=3200
        IHLP=LPROC-ILBL-60-JHIGGS*10
        IF(LPROC.LT.ILBL+70)IHLP=LPROC-ILBL-30-JHIGGS*10
        IF(LPROC.LT.ILBL+40)IHLP=LPROC-ILBL   -JHIGGS*10
        IF(IHLP.LE.8)ISIGN=-1
        IF(IHLP.LE.4)ISIGN=+1
        JHLP=IHLP/5
        KHLP=IHLP/(3+4*JHLP)
        ISQ1=405+JHLP+12*KHLP
        IF(ILBL.EQ.3100)THEN
          ISQ2=ISQ1+ITMP(IHLP)+6+ISIGN
          IF(ISIGN.EQ.+1)JH=206
          IF(ISIGN.EQ.-1)JH=207
          IF(ISIGN.EQ.+1)JHIGGS=4
          IF(ISIGN.EQ.-1)JHIGGS=5
        ELSE IF(ILBL.EQ.3200)THEN
          ISQ2=ISQ1+ITMP(IHLP)+6
          IF(JHIGGS.EQ.1)JH=203
          IF(JHIGGS.EQ.2)JH=204
          IF(JHIGGS.EQ.3)JH=205
        END IF
        IF1MIN=ISQ1
        IF1MAX=ISQ1
        IF2MIN=ISQ2
        IF2MAX=ISQ2
        IF((LPROC.EQ.3110).OR.(LPROC.EQ.3210).OR.
     &     (LPROC.EQ.3220).OR.(LPROC.EQ.3230).OR.
     &     (LPROC.EQ.3140).OR.(LPROC.EQ.3240).OR.
     &     (LPROC.EQ.3250).OR.(LPROC.EQ.3260).OR.
     &     (LPROC.EQ.3170).OR.(LPROC.EQ.3270).OR.
     &     (LPROC.EQ.3280).OR.(LPROC.EQ.3290))THEN
          IF1MIN=405
          IF1MAX=418
          IF2MIN=411
          IF2MAX=424
        END IF
      ELSE IF(LPROC/100.EQ.33)THEN
        IF((LPROC.EQ.3350).OR.(LPROC.EQ.3355))THEN
          IMSSM=-1
          IHIGGS=206-201
        ELSE IF((LPROC.EQ.3310).OR.(LPROC.EQ.3320).OR.
     &          (LPROC.EQ.3360).OR.(LPROC.EQ.3370))THEN
          KPROC=MIN(3351,LPROC)
          IV=MAX(KPROC-3350,0)
          IF((IV.LT.0).OR.(IV.GT.1))CALL HWWARN('HWUINC',611,*999)
          IH=LPROC/10-330-5*IV
          IF((IH.LE.0).OR.(IH.GT.2))CALL HWWARN('HWUINC',610,*999)
          IF(LPROC.LE.3320)IMSSM=LPROC-2600
          IF(LPROC.GE.3360)IMSSM=LPROC-2700
C...assign enhancement for MSSM Higgs-VV couplings, V->W,Z-gauge bosons.
          DO 555 I=10,10
            ENHANC(I  )=GHWWSS(IH)
            ENHANC(I+1)=GHZZSS(IH)
 555      CONTINUE
          IF(IH.EQ.1)IHIGGS=203-201
          IF(IH.EQ.2)IHIGGS=204-201
          IF(IH.EQ.3)IHIGGS=205-201
        ELSE IF((LPROC.EQ.3315).OR.(LPROC.EQ.3365))THEN
          IHIGGS=203-201
          IMSSM=-1
        ELSE IF((LPROC.EQ.3325).OR.(LPROC.EQ.3375))THEN
          IHIGGS=204-201
          IMSSM=-1
        ELSE IF(LPROC.EQ.3335)THEN
          IHIGGS=205-201
          IMSSM=-1
        ELSE
          CALL HWWARN('HWUINC',609,*999)
        END IF
      ELSE IF(LPROC/100.EQ.34)THEN
        IMSSM=-1
        IF(LPROC.EQ.3410)IHIGGS=203-201
        IF(LPROC.EQ.3420)IHIGGS=204-201
        IF(LPROC.EQ.3430)IHIGGS=205-201
        IF(LPROC.EQ.3450)IHIGGS=206-201
        IF(IHIGGS.EQ.0)CALL HWWARN('HWUINC',608,*999)
      ELSE IF(LPROC/100.EQ.35)THEN
        IMSSM=-1
        IHIGGS=206-201
      ELSE IF(LPROC/100.EQ.36)THEN
        IF((LPROC.NE.3610).AND.(LPROC.NE.3620).AND.(LPROC.NE.3630))
     &  CALL HWWARN('HWUINC',607,*999)
        IH=LPROC/10-360
        IF((IH.LE.0).OR.(IH.GT.3))CALL HWWARN('HWUINC',606,*999)
        ID=LPROC-3600-10*IH
        IF((ID.LT.0).OR.(ID.GT.9))CALL HWWARN('HWUINC',605,*999)
        IMSSM=LPROC-(1600+ID)
C...assign Neutral MSSM Higgs parity.
        IF(IH.EQ.3)PARITY=-1
        DO 222 I=1,5,2
C...assign enhancement for Neutral MSSM Higgs-QQ couplings, Q->U,D-type quarks.
          ENHANC(I)=GHDDSS(IH)
          ENHANC(I+1)=GHUUSS(IH)
 222    CONTINUE
C...assign enhancement for Neutral MSSM Higgs-Q~Q~ couplings,
C   Q~->U,D-type squarks.
        DO 223 I=1,6
          SENHNC(I   )=RMASS(198)*GHSQSS(IH,I,1,1)/RMASS(400+I)**2
          SENHNC(I+12)=RMASS(198)*GHSQSS(IH,I,2,2)/RMASS(412+I)**2
 223    CONTINUE
        IF(IH.EQ.1)IHIGGS=203-201
        IF(IH.EQ.2)IHIGGS=204-201
        IF(IH.EQ.3)IHIGGS=205-201
      ELSE IF(LPROC/100.EQ.37)THEN
        IH=LPROC/10-370
        IF((IH.LE.0).OR.(IH.GT.2))CALL HWWARN('HWUINC',604,*999)
        IMSSM=LPROC-1900
C...assign enhancement for MSSM Higgs-VV couplings, V->W,Z-gauge bosons.
        DO 333 I=10,10
          ENHANC(I  )=GHWWSS(IH)
          ENHANC(I+1)=GHZZSS(IH)
 333    CONTINUE
        IF(IH.EQ.1)IHIGGS=203-201
        IF(IH.EQ.2)IHIGGS=204-201
        IF(IH.EQ.3)IHIGGS=205-201
      ELSE IF(LPROC/100.EQ.38)THEN
        IMSSM=-1
        IF((LPROC.EQ.3839).OR.(LPROC.EQ.3869).OR.(LPROC.EQ.3899))THEN
          IHIGGS=207-201
          PARITY=1
          GOTO 445
        END IF
        IF(LPROC.LT.4000)IS=6
        IF(LPROC.LT.3870)IS=3
        IF(LPROC.LT.3840)IS=0
        IH=LPROC/10-380-IS
        IF((IH.LE.0).OR.(IH.GT.3))CALL HWWARN('HWUINC',603,*999)
        IQ=LPROC-3800-10*(IH+IS)
        IF((IQ.LE.0).OR.(IQ.GT.6))CALL HWWARN('HWUINC',602,*999)
C...assign Neutral MSSM Higgs parity.
        PARITY=IP(IH)
C...assign enhancement for MSSM Higgs-QQ couplings, Q->U,D-type quarks.
        DO 444 I=1,5,2
          ENHANC(I  )=GHDDSS(IH)
          ENHANC(I+1)=GHUUSS(IH)
 444    CONTINUE
        IF(IH.EQ.1)IHIGGS=203-201
        IF(IH.EQ.2)IHIGGS=204-201
        IF(IH.EQ.3)IHIGGS=205-201
 445    CONTINUE
      END IF
      IF((IMSSM.NE.-1).AND.(IPROC.GE.10000))IMSSM=IMSSM+10000
 666  CONTINUE
      IPRO=MOD(IPROC/100,100)
      IQK=MOD(IPROC,100)
C---SET UP BEAMS
      CALL HWUIDT(3,IDB,IPART1,PART1)
      CALL HWUIDT(3,IDT,IPART2,PART2)
      EBEAM1=SQRT(PBEAM1**2+RMASS(IPART1)**2)
      EBEAM2=SQRT(PBEAM2**2+RMASS(IPART2)**2)
C---PHOTON CUTOFF DEFAULTS TO ROOT S
      PTLIM=SQRT(HALF*(EBEAM1*EBEAM2+PBEAM1*PBEAM2))
      ETLIM=TWO*PTLIM
      IF (VPCUT.GT.ETLIM) VPCUT=ETLIM
      IF (Q2MAX.GT.ETLIM**2) Q2MAX=ETLIM**2
C---PRINT OUT MOST IMPORTANT INPUT PARAMETERS
      IF (IPRINT.EQ.0) GOTO 50
      WRITE (6,10) PART1,PBEAM1,PART2,PBEAM2,IPROC,
     & NFLAV,NSTRU,AZSPIN,AZSOFT,QCDLAM,(RMASS(I),I=1,6),RMASS(13)
      IF (ISPAC.LE.1) THEN
        WRITE (6,20) VQCUT,VGCUT,VPCUT,CLMAX,QSPAC,PTRMS
      ELSE
        WRITE (6,30) VQCUT,VGCUT,VPCUT,CLMAX,QSPAC,PTRMS
      ENDIF
C--switch on three body matrix elements if doing spin correlations
      IF(SYSPIN) THREEB=.TRUE.
C--output spin correlation options
      WRITE(6,35) SYSPIN,THREEB,FOURB
      IF (NOSPAC) WRITE (6,40)
  10  FORMAT(/10X,'INPUT CONDITIONS FOR THIS RUN'//
     &        10X,'BEAM 1 (',A8,') MOM. =',F10.2/
     &        10X,'BEAM 2 (',A8,') MOM. =',F10.2/
     &        10X,'PROCESS CODE (IPROC)   =',I8/
     &        10X,'NUMBER OF FLAVOURS     =',I5/
     &        10X,'STRUCTURE FUNCTION SET =',I5/
     &        10X,'AZIM SPIN CORRELATIONS =',L5/
     &        10X,'AZIM SOFT CORRELATIONS =',L5/
     &        10X,'QCD LAMBDA (GEV)       =',F10.4/
     &        10X,'DOWN     QUARK  MASS   =',F10.4/
     &        10X,'UP       QUARK  MASS   =',F10.4/
     &        10X,'STRANGE  QUARK  MASS   =',F10.4/
     &        10X,'CHARMED  QUARK  MASS   =',F10.4/
     &        10X,'BOTTOM   QUARK  MASS   =',F10.4/
     &        10X,'TOP      QUARK  MASS   =',F10.4/
     &        10X,'GLUON EFFECTIVE MASS   =',F10.4)
  20  FORMAT(10X,'EXTRA SHOWER CUTOFF (Q)=',F10.4/
     &       10X,'EXTRA SHOWER CUTOFF (G)=',F10.4/
     &       10X,'PHOTON SHOWER CUTOFF   =',F10.4/
     &       10X,'CLUSTER MASS PARAMETER =',F10.4/
     &       10X,'SPACELIKE EVOLN CUTOFF =',F10.4/
     &       10X,'INTRINSIC P-TRAN (RMS) =',F10.4)
  30  FORMAT(10X,'EXTRA SHOWER CUTOFF (Q)=',F10.4/
     &       10X,'EXTRA SHOWER CUTOFF (G)=',F10.4/
     &       10X,'PHOTON SHOWER CUTOFF   =',F10.4/
     &       10X,'CLUSTER MASS PARAMETER =',F10.4/
     &       10X,'PDF FREEZING CUTOFF    =',F10.4/
     &       10X,'INTRINSIC P-TRAN (RMS) =',F10.4)
  35  FORMAT(10X,'DECAY SPIN CORRELATIONS=',L5/
     &       10X,'SUSY THREE BODY ME     =',L5/
     &       10X,'SUSY FOUR  BODY ME     =',L5)
  40  FORMAT(10X,'NO SPACE-LIKE SHOWERS')
  50  ISTOP=0
C---INITIALIZE ALPHA-STRONG
      IF (QLIM.GT.ETLIM) QLIM=ETLIM
      QR=HWUALF(0,QLIM)
C---DO SOME SAFETY CHECKS ON INPUT PARAMETERS
C Check beam order for point-like photon/QCD processes
      IF (IPRO.GE.50.AND.IPRO.LE.59.AND.
     &     IDB.NE.22.AND.ABS(IDB).NE.11.AND.ABS(IDB).NE.13) THEN
         WRITE(6,60)
  60     FORMAT(1X,'WARNING: require FIRST beam to be a photon/lepton')
         ISTOP=ISTOP+1
      ENDIF
      QG=HWBVMC(13)
      QR=QG/QCDL3
      IF (QR.GE.2.01) GOTO 80
      WRITE (6,70) QG,QCDLAM,QCDL3
  70  FORMAT(//10X,'SHOWER GLUON VIRTUAL MASS CUTOFF =',F8.5/
     &         10X,'TOO SMALL RELATIVE TO QCD LAMBDA =',F8.5/
     &         10X,'CORRESPONDS TO  3-FLAV MC LAMBDA =',F8.5)
      ISTOP=ISTOP+1
  80  QV=MIN(HWBVMC(1),HWBVMC(2))
      IF (QV.GE.QG/(QR-1.)) GOTO 100
      ISTOP=ISTOP+1
      WRITE (6,90) QV,QCDLAM,QCDL3
  90  FORMAT(//10X,'SHOWER QUARK VIRTUAL MASS CUTOFF =',F8.5/
     &         10X,'TOO SMALL RELATIVE TO QCD LAMBDA =',F8.5/
     &         10X,'CORRESPONDS TO  3-FLAV MC LAMBDA =',F8.5)
  100 IF (ISTOP.NE.0) THEN
        WRITE (6,110) ISTOP
  110   FORMAT(//10X,'EXECUTION PREVENTED BY',I2,
     &  ' ERRORS IN INPUT PARAMETERS.')
        STOP
      ENDIF
      DO 120 I=1,6
  120 RMASS(I+6)=RMASS(I)
      RMASS(199)=RMASS(198)
C---A PRIORI WEIGHTS FOR QUARK AND DIQUARKS
      DQKWT=PWT(1)
      UQKWT=PWT(2)
      SQKWT=PWT(3)
      DIQWT=PWT(7)
      PWT(10)=PWT(4)
      PWT(11)=PWT(5)
      PWT(12)=PWT(6)
C
      PWT(4)=UQKWT*UQKWT*DIQWT
      PWT(5)=UQKWT*DQKWT*DIQWT*HALF
      PWT(6)=DQKWT*DQKWT*DIQWT
      PWT(7)=UQKWT*SQKWT*DIQWT*HALF
      PWT(8)=DQKWT*SQKWT*DIQWT*HALF
      PWT(9)=SQKWT*SQKWT*DIQWT
      QMAX=MAX(PWT(1),PWT(2),PWT(3))
      PMAX=MAX(PWT(4),PWT(5),PWT(6),PWT(7),PWT(8),PWT(9),
     &         PWT(10),PWT(11),PWT(12),QMAX)
      PMAX=1./PMAX
      QMAX=1./QMAX
      DO 130 I=1,3
  130 QWT(I)=PWT(I)*QMAX
      DO 140 I=1,12
  140 PWT(I)=PWT(I)*PMAX
C  MASSES OF DIQUARKS (ASSUME BINDING NEGLIGIBLE)
      RMASS(109)=RMASS(2)+RMASS(2)
      RMASS(110)=RMASS(1)+RMASS(2)
      RMASS(111)=RMASS(1)+RMASS(1)
      RMASS(112)=RMASS(2)+RMASS(3)
      RMASS(113)=RMASS(1)+RMASS(3)
      RMASS(114)=RMASS(3)+RMASS(3)
      DO 150 I=109,114
  150 RMASS(I+6)=RMASS(I)
C  MASSES OF TOP HADRONS (ASSUME BINDING NEGLIGIBLE)
      RMASS(232)=RMASS(6)+RMASS(5)
      RMASS(233)=RMASS(6)+RMASS(1)
      RMASS(234)=RMASS(6)+RMASS(2)
      RMASS(235)=RMASS(6)+RMASS(3)
      RMASS(236)=RMASS(6)+RMASS(2)+RMASS(2)
      RMASS(237)=RMASS(6)+RMASS(1)+RMASS(2)
      RMASS(238)=RMASS(6)+RMASS(1)+RMASS(1)
      RMASS(239)=RMASS(6)+RMASS(2)+RMASS(3)
      RMASS(240)=RMASS(6)+RMASS(1)+RMASS(3)
      RMASS(241)=RMASS(6)+RMASS(3)+RMASS(3)
      RMASS(242)=RMASS(6)+RMASS(4)
      RMASS(243)=RMASS(6)+RMASS(5)
      RMASS(244)=RMASS(6)+RMASS(6)
      RMASS(232)=RMASS(243)
      DO 160 I=233,242
  160 RMASS(I+22)=RMASS(I)
C Set up an array of cluster mass threholds
      CLMXPW=CLMAX**CLPOW
      RCLPOW=ONE/CLPOW
      CALL HWVZRO(144,CTHRPW(1,1))
      DO 170 I=1,6
      DO 170 J=1,6
      CTHRPW(I ,J  )=(CLMXPW+(RMASS(I    )+RMASS(J+6  ))**CLPOW)**RCLPOW
      CTHRPW(I ,J+6)=(CLMXPW+(RMASS(I    )+RMASS(J+108))**CLPOW)**RCLPOW
  170 CTHRPW(I+6,J )=(CLMXPW+(RMASS(I+114)+RMASS(J+6  ))**CLPOW)**RCLPOW
C Decay length conversion factor GEV2MM hbar.c/e
      GEV2MM=1.D-15*SQRT(GEV2NB/10.)
C Plank's constant/2pi (GeV.s)
      HBAR=GEV2MM/CSPEED
C Check the SUSY DATA has been read in (if needed)
      IF((IPRO.EQ.7.OR.IPRO.EQ.8.OR.IPRO.EQ.9.OR.IPRO.EQ.11.
     &OR.(IPRO.GE.30.AND.IPRO.LE.41)).AND..NOT.SUSYIN)
     &     CALL HWWARN('HWUINC',601,*999)
C---IMPORTANCE SAMPLING
      FIRST=.TRUE.
      XMIN=0
      XMAX=0
      XPOW=-1
      IF (IPRO.EQ.5) THEN
        IF (EMMAX.GT.ETLIM)  EMMAX=ETLIM
        IF (PTMAX.GT.PTLIM)  PTMAX=PTLIM
      ELSEIF (IPRO.EQ.13) THEN
        IF (EMMIN.EQ.ZERO)   EMMIN=10
        IF (EMMAX.GT.ETLIM)  EMMAX=ETLIM
        IF (IQK.GT.0.AND.IQK.LE.6) EMMIN=MAX(EMMIN,2*RMASS(IQK))
        XMIN=EMMIN
        XMAX=EMMAX
        XPOW=-EMPOW
      ELSEIF (IPRO.EQ.15.OR.IPRO.EQ.17.OR.IPRO.EQ.18.OR.IPRO.EQ.21
     &    .OR.IPRO.EQ.22.OR.IPRO.EQ.23.OR.IPRO.EQ.24.OR.IPRO.EQ.50
     &    .OR.IPRO.EQ.51.OR.IPRO.EQ.53.OR.IPRO.EQ.55.OR.IPRO.EQ.60) THEN
        IF (PTMAX.GT.PTLIM)  PTMAX=PTLIM
        IF (IQK.NE.0.AND.IQK.LT.7.AND.IPRO.NE.23) THEN
          XMIN=2.*SQRT(PTMIN**2+RMASS(IQK)**2)
          XMAX=2.*SQRT(PTMAX**2+RMASS(IQK)**2)
          IF (XMAX.GT.ETLIM)  XMAX=ETLIM
        ELSE
          XMIN=2.*PTMIN
          XMAX=2.*PTMAX
        ENDIF
        XPOW=-PTPOW
C--Gauge Boson pairs in hadron-hadron
      ELSEIF(IPRO.EQ.28) THEN
        IF(EMMIN.EQ.ZERO) EMMIN=20.0D0
C--Drell-Yan + 2 jets processes
      ELSEIF(IPRO.EQ.29) THEN
        IF(EMMIN.EQ.ZERO) EMMIN=20.0D0
        IF(PTMAX.GT.ETLIM) PTMAX = ETLIM
C--Cuts on the graviton to avoid unitarity violations
C--If the width exceeds 0.1 times the mass this should be reset
      ELSEIF(IPRO.EQ.42) THEN
         EMMIN = 0.9D0*EMGRV
         EMMAX = 1.1D0*EMGRV
      ELSEIF (IPRO.EQ.52) THEN
        PTELM=PTLIM-RMASS(IQK)**2/(4.*PTLIM)
        IF (PTMAX.GT.PTELM) PTMAX=PTELM
        XMIN=PTMIN
        XMAX=PTMAX
        XPOW=-PTPOW
      ELSEIF (IPRO.EQ.30) THEN
        IF (PTMAX.GT.PTLIM)  PTMAX=PTLIM
        XMIN=2.*SQRT(PTMIN**2+RMMNSS**2)
        XMAX=2.*SQRT(PTMAX**2+RMMNSS**2)
        IF (XMAX.GT.ETLIM)  XMAX=ETLIM
        XPOW=-PTPOW
C--PR MOD 7/7/99
      ELSEIF(IPRO.EQ.40.OR.IPRO.EQ.41) THEN
        IF (PTMAX.GT.PTLIM)  PTMAX=PTLIM
          ID = MOD(IPROC,100)
          RPM(1) = RMMNSS
          RPM(2) = ZERO
          IF(ID.GE.10.AND.ID.LT.20) THEN
            RPM(1) = ABS(RMASS(450))
            IF(ID.GT.10) RPM(1) = ABS(RMASS(449+MOD(ID,10)))
          ELSEIF(ID.GE.20.AND.ID.LT.30) THEN
            RPM(1) = ABS(RMASS(454))
            IF(ID.GT.20) RPM(1) = ABS(RMASS(453+MOD(ID,20)))
          ELSEIF(ID.EQ.30) THEN
            RPM(1) = RMASS(449)
          ELSEIF(ID.EQ.40) THEN
            IF(IPRO.EQ.40) THEN
              RPM(1) = RMASS(425)
              DO I=1,5
                RPM(1) = MIN(RPM(1),RMASS(425+I))
              ENDDO
            ELSE
              RPM(1) = MIN(RMASS(405),RMASS(406))
            ENDIF
            RPM(2) = RMASS(198)
          ELSEIF(ID.EQ.50) THEN
            IF(IPRO.EQ.40) THEN
              RPM(1) = RMASS(425)
              DO I=1,5
                RPM(1) = MIN(RPM(1),RMASS(425+I))
              ENDDO
              DO I=1,3
                RPM(2) = MIN(RPM(1),RMASS(433+2*I))
              ENDDO
              RPM(1) = MIN(RPM(1),RPM(2))
              RPM(2) = RMASS(203)
              DO I=1,2
                RPM(2) = MIN(RPM(2),RMASS(204+I))
              ENDDO
            ELSE
              RPM(1) = RMASS(401)
              RPM(2) = RMASS(413)
              DO I=1,5
                RPM(1) = MIN(RPM(1),RMASS(401+I))
                RPM(2) = MIN(RPM(2),RMASS(413+I))
              ENDDO
              RPM(1) = MIN(RPM(1),RPM(2))
              RPM(2) = RMASS(203)
              DO I=1,2
                RPM(2) = MIN(RPM(2),RMASS(204+I))
              ENDDO
            ENDIF
            RPM(2) = RMASS(203)
            DO I=1,2
              RPM(2) = MIN(RPM(2),RMASS(204+I))
            ENDDO
          ELSEIF(ID.GE.60) THEN
            RPM(1) = ZERO
          ENDIF
          RPM(1) = RPM(1)**2
          RPM(2) = RPM(2)**2
          XMIN = SQRT(RPM(1)+RPM(2)+TWO*(PTMIN**2+
     &           SQRT(RPM(1)*RPM(2)+PTMIN**2*(RPM(1)+RPM(2)+PTMIN**2))))
          XMAX = SQRT(RPM(1)+RPM(2)+TWO*(PTMAX**2+
     &           SQRT(RPM(1)*RPM(2)+PTMAX**2*(RPM(1)+RPM(2)+PTMAX**2))))
        IF (XMAX.GT.ETLIM)  XMAX=ETLIM
C--end of mod
      ELSEIF (IPRO.EQ.90) THEN
        XMIN=SQRT(Q2MIN)
        XMAX=SQRT(Q2MAX)
        XPOW=1.-2.*Q2POW
      ELSEIF (IPRO.EQ.91) THEN
        IF (EMMAX.GT.ETLIM) EMMAX=ETLIM
      ENDIF
C---CALCULATE HIGGS WIDTH
      IF (IPRO.EQ. 3.OR.IPRO.EQ. 4.OR.IPRO.EQ.10.OR.IPRO.EQ.16
     &.OR.IPRO.EQ.19.OR.IPRO.EQ.23.OR.IPRO.EQ.25.OR.IPRO.EQ.26
     &.OR.IPRO.EQ.27.OR.IPRO.EQ.95) THEN
        GAMH=RMASS(201)
        CALL HWDHIG(GAMH)
      ENDIF
C---IF Q**2 CAN BE TOO SMALL, BREIT FRAME MAKES NO SENSE
      IF ((IPRO/10.EQ.9.AND.Q2MIN.LE.1.D-2).OR.
     &    (IPRO.EQ.91.AND.IQK.EQ.7)) BREIT=.FALSE.
      IF (IPRINT.NE.0) THEN
        IF (PBEAM1.NE.PBEAM2) WRITE (6,180) USECMF
        IF (IPRO.EQ.91.OR.IPRO.EQ.92)
     &      WRITE (6,190) PTMIN
        IF (IPRO.EQ.90.OR.(IPRO.EQ.91.AND.IQK.NE.7).OR.IPRO.EQ.92)
     &      WRITE (6,200) Q2MIN,Q2MAX,BREIT
        IF (IPRO.EQ.90.OR.(IPRO.EQ.91.AND.IQK.NE.7).OR.IPRO.EQ.92)
     &      WRITE (6,210) YBMIN,YBMAX
        IF (IPRO.EQ.91.AND.IQK.EQ.7)
     &      WRITE (6,220) Q2WWMN,Q2WWMX,BREIT,ZJMAX
        IF (IPROC/10.EQ.11) WRITE (6,230) THMAX
        IF (IPRO.EQ.13) WRITE (6,240) EMMIN,EMMAX
        IF (IPRO.EQ.15.OR.IPRO.EQ.17.OR.IPRO.EQ.18.OR.IPRO.EQ.21
     &  .OR.IPRO.EQ.22.OR.IPRO.EQ.23.OR.IPRO.EQ.24.OR.IPRO.EQ.50
     &  .OR.IPRO.EQ.51.OR.IPRO.EQ.52.OR.IPRO.EQ.53.OR.IPRO.EQ.55
     &  .OR.IPRO.EQ.60)
     &      WRITE (6,250) PTMIN,PTMAX
        IF (IPRO.EQ. 3.OR.IPRO.EQ. 4.OR.IPRO.EQ.10.OR.IPRO.EQ.16
     &  .OR.IPRO.EQ.19.OR.IPRO.EQ.23.OR.IPRO.EQ.25.OR.IPRO.EQ.26
     &  .OR.IPRO.EQ.27.OR.IPRO.EQ.95)
     &      WRITE (6,260) RMASS(201),GAMH,
     &      GAMMAX,RMASS(201)+GAMMAX*GAMH,(BRHIG(I)*100,I=1,12)
        IF (IPRO.EQ.91) WRITE (6,270) BGSHAT,EMMIN,EMMAX
        IF (IPRO.EQ.5.AND.IQK.LT.50)
     &      WRITE (6,280) EMMIN,EMMAX,PTMIN,PTMAX,CTMAX
        IF (IPRO.EQ.5.AND.IQK.GE.50)
     &      WRITE (6,290) EMMIN,EMMAX,Q2MIN,Q2MAX,PTMIN
        IF (IPRO.GT.12.AND.
     &    (IPRO.LT.90.AND.(ABS(IDB).EQ.11.OR.ABS(IDB).EQ.13).OR.
     &                    (ABS(IDT).EQ.11.OR.ABS(IDT).EQ.13))) THEN
          WRITE (6,300) Q2WWMN,Q2WWMX,YWWMIN,YWWMAX
          IF (PHOMAS.GT.ZERO) WRITE (6,310) PHOMAS
        ENDIF
        IF (IPROC/10.EQ.10.OR.IPRO.EQ.90)
     &      WRITE (6,320) HARDME,SOFTME
C  Check minimum mass threshold if ISR switched on
        IF ((IPRO.LE.3.OR.IPRO.EQ.6).AND.ZMXISR.GT.ZERO) THEN
          TEST=TWO*RMASS(IPART1)**2+ETLIM**2
          TEST=FOUR*RMASS(2)**2/TEST
          IF (TMNISR.LT.TEST) THEN
            WRITE(6,175) TMNISR,TEST
  175       FORMAT(10X,'Minimum invariant mass',F10.6,' too low'/
     &             10X,'increasing to  TMNISR=',F10.6)
            TMNISR=TEST
          ENDIF
          WRITE (6,330) TMNISR,ONE-ZMXISR
        ENDIF
        IF (WHMIN.GT.ZERO .AND. IPRO.GT.12.AND.(IPRO.EQ.90.OR.
     &       (ABS(IDB).EQ.11.OR.ABS(IDB).EQ.13).OR.
     &       (ABS(IDT).EQ.11.OR.ABS(IDT).EQ.13))) WRITE (6,340) WHMIN
  180   FORMAT(10X,'USE BEAM-TARGET C.M.F. =',L5)
  190   FORMAT(10X,'MIN P-T FOR O(AS) DILS =',F10.4)
  200   FORMAT(10X,'MIN ABS(Q**2) FOR DILS =',E10.4/
     &         10X,'MAX ABS(Q**2) FOR DILS =',E10.4/
     &         10X,'BREIT FRAME SHOWERING  =',L5)
  210   FORMAT(10X,'MIN BJORKEN Y FOR DILS =',F10.4/
     &         10X,'MAX BJORKEN Y FOR DILS =',F10.4)
  220   FORMAT(10X,'MIN ABS(Q**2) FOR J/PSI=',E10.4/
     &         10X,'MAX ABS(Q**2) FOR J/PSI=',E10.4/
     &         10X,'BREIT FRAME SHOWERING  =',L5/
     &         10X,'MAX Z FOR J/PSI        =',F10.4)
  230   FORMAT(10X,'MAX THRUST FOR 2->3    =',F10.4)
  240   FORMAT(10X,'MIN MASS FOR DRELL-YAN =',F10.4/
     &         10X,'MAX MASS FOR DRELL-YAN =',F10.4)
  250   FORMAT(10X,'MIN P-TRAN FOR 2->2    =',F10.4/
     &         10X,'MAX P-TRAN FOR 2->2    =',F10.4)
  260   FORMAT(10X,'HIGGS BOSON MASS       =',F10.4/
     &         10X,'HIGGS BOSON WIDTH      =',F10.4/
     &         10X,'CUTOFF = EMH +',F4.1,'*GAMH=',F10.4/
     &         10X,'HIGGS          D DBAR  =',F10.4/
     &         10X,'BRANCHING      U UBAR  =',F10.4/
     &         10X,'FRACTIONS      S SBAR  =',F10.4/
     &         10X,'(PER CENT)     C CBAR  =',F10.4/
     &         10X,'               B BBAR  =',F10.4/
     &         10X,'               T TBAR  =',F10.4/
     &         10X,'              E+ E-    =',F10.4/
     &         10X,'             MU+ MU-   =',F10.4/
     &         10X,'            TAU+ TAU-  =',F10.4/
     &         10X,'               W W     =',F10.4/
     &         10X,'               Z Z     =',F10.4/
     &         10X,'           GAMMA GAMMA =',F10.4)
  270   FORMAT(10X,'SCALE FOR BGF IS S-HAT =',L5/
     &         10X,'MIN MASS FOR BGF       =',F10.4/
     &         10X,'MAX MASS FOR BGF       =',F10.4)
  280   FORMAT(10X,'MIN MASS FOR 2 PHOTONS =',F10.4/
     &         10X,'MAX MASS FOR 2 PHOTONS =',F10.4/
     &         10X,'MIN PT OF 2 PHOTON CMF =',F10.4/
     &         10X,'MAX PT OF 2 PHOTON CMF =',F10.4/
     &         10X,'MAX COS THETA IN CMF   =',F10.4)
  290   FORMAT(10X,'MIN MASS FOR GAMMA + W =',F10.4/
     &         10X,'MAX MASS FOR GAMMA + W =',F10.4/
     &         10X,'MIN ABS(Q**2)          =',E10.4/
     &         10X,'MAX ABS(Q**2)          =',E10.4/
     &         10X,'MIN PT                 =',F10.4)
  300   FORMAT(10X,'MIN Q**2 FOR WW PHOTON =',F10.4/
     &         10X,'MAX Q**2 FOR WW PHOTON =',F10.4/
     &         10X,'MIN MOMENTUM FRACTION  =',F10.4/
     &         10X,'MAX MOMENTUM FRACTION  =',F10.4)
  310   FORMAT(10X,'GAMMA* S.F. MASS PARAM =',F10.4)
  320   FORMAT(10X,'HARD M.E. MATCHING     =',L5/
     &         10X,'SOFT M.E. MATCHING     =',L5)
  330   FORMAT(10X,'MIN MTM FRAC FOR ISR   =',1PE10.4/
     &         10X,'1-MAX MTM FRAC FOR ISR =',1PE10.4)
  340   FORMAT(10X,'MINIMUM HADRONIC MASS  =',F10.4)
        IF (LWEVT.LE.0) THEN
          WRITE (6,350)
        ELSE
          WRITE (6,360) LWEVT
        ENDIF
  350   FORMAT(/10X,'NO EVENTS WILL BE WRITTEN TO DISK')
  360   FORMAT(/10X,'EVENTS WILL BE OUTPUT ON UNIT',I4)
      ENDIF
C Verify and print beam polarisations
      IF((IPRO.EQ.1.OR.IPRO.EQ.3).OR.
     &  ((IPRO.EQ.9).AND.(MOD(IPROC,10000).EQ.960)).OR.
     &  ((IPRO.EQ.9).AND.(MOD(IPROC,10000).EQ.970)))THEN
C Set up transverse polarisation parameters for e+e-
        IF ((EPOLN(1)**2+EPOLN(2)**2)
     &     *(PPOLN(1)**2+PPOLN(2)**2).GT.ZERO) THEN
          TPOL=.TRUE.
          COSS=EPOLN(1)*PPOLN(1)-EPOLN(2)*PPOLN(2)
          SINS=EPOLN(2)*PPOLN(1)+EPOLN(1)*PPOLN(2)
        ELSE
          TPOL=.FALSE.
        ENDIF
C print out lepton beam polarisation(s)
        IF (IPRINT.NE.0) THEN
          IF (IPART1.EQ.121) THEN
            WRITE (6,370) PART1,EPOLN,PART2,PPOLN
          ELSE
            WRITE (6,370) PART1,PPOLN,PART2,EPOLN
          ENDIF
 370      FORMAT(/10X,A8,'Beam polarisation=',3F10.4/
     &            10X,A8,'Beam polarisation=',3F10.4)
        ENDIF
      ELSEIF (IPRO.GE.90.AND.IPRO.LE.99) THEN
        IF (IDB.GE.11.AND.IDB.LE.16) THEN
          CALL HWVZRO(3,PPOLN)
C Check neutrino polarisations for DIS
          IF (IDB.EQ. 12.OR.IDB.EQ. 14.OR.IDB.EQ. 16.AND.
     &        EPOLN(3).NE.-ONE) EPOLN(3)=-ONE
          IF (IPRINT.NE.0) WRITE(6,380) PART1,EPOLN(3)
        ELSE
          CALL HWVZRO(3,EPOLN)
C Check anti-neutrino polarisations for DIS
          IF (IDB.EQ.-12.OR.IDB.EQ.-14.OR.IDB.EQ.-16.AND.
     &        PPOLN(3).NE.ONE) PPOLN(3)=ONE
          IF (IPRINT.NE.0) WRITE(6,380) PART1,PPOLN(3)
        ENDIF
 380    FORMAT(/10X,A8,1X,'Longitudinal beam polarisation=',F10.4/)
      ENDIF
      IF (IPRINT.NE.0) THEN
        IF (ZPRIME) THEN
          WRITE(6,390) RMASS(200),RMASS(202),GAMZ,GAMZP
          WRITE(6,400) (RNAME(I),VFCH(I,1),AFCH(I,1),VFCH(I,2),
     &                  AFCH(I,2),I=1,6)
          WRITE(6,400) (RNAME(110+I),VFCH(I,1),AFCH(I,1),
     &                  VFCH(I,2),AFCH(I,2),I=11,16)
  390     FORMAT(/10X,'MASSIVE NEUTRAL VECTOR BOSON PARAMS'/
     &            10X,'Z   MASS=',F10.4,7X,'Z-PRIME MASS=',F10.4/
     &            10X,'   WIDTH=',F10.4,7X,'       WIDTH=',F10.4/
     &            10X,'FERMION COUPLINGS: e.(V.1+A.G_5)G_mu'/
     &            10X,'FERMION:  VECTOR     AXIAL',6X,
     &                'VECTOR     AXIAL'/)
  400     FORMAT(10X,A8,2X,F10.4,1X,F10.4,1X,F10.4,1X,F10.4)
        ENDIF
        IF (MIXING) THEN
          WRITE(6,410) XMIX(2),YMIX(2),XMIX(1),YMIX(1)
  410     FORMAT(/10X,'B_d: Delt-M/Gam =',F6.4,
     &                ' Delt-Gam/2*Gam =',F6.4,/
     &            10X,'B_s: Delt-M/Gam =',F6.2,
     &                ' Delt-Gam/2*Gam =',F6.4)
        ENDIF
        IF (CLRECO) WRITE(6,420) PRECO,EXAG
  420   FORMAT(/10X,'Colour rearrangement ALLOWED, probability =',F6.4,/
     &          10x,'Weak boson life-time exaggeration factor =',F10.6)
C---PDF STRUCTURE FUNCTIONS
        WRITE (6,'(1X)')
        DO 450 I=1,2
          IF (MODPDF(I).GE.0) THEN
            WRITE (6,430) I,MODPDF(I),AUTPDF(I)
          ELSE
            WRITE (6,440) I
          ENDIF
 430      FORMAT(10X,'PDFLIB USED FOR BEAM',I2,': SET',I3,' OF ',A20)
 440      FORMAT(10X,'PDFLIB NOT USED FOR BEAM',I2)
 450    CONTINUE
C---GET THE UGLY INITIALISATION MESSAGES OVER AND DONE WITH NOW TOO
        DO 460 I=1,2
          IF (MODPDF(I).GE.0) THEN
            PARM(1)=AUTPDF(I)
            VAL(1)=MODPDF(I)
            FSTPDF=.TRUE.
            X=0.5
            QSCA=10
C---FIX TO CALL SCHULER-SJOSTRAND CODE
            IF (AUTPDF(I).EQ.'SaSph') THEN
              ISET=MOD(MODPDF(I),10)
              IOP1=MOD(MODPDF(I)/10,2)
              IOP2=MOD(MODPDF(I)/20,2)
              IP2=MODPDF(I)/100
              IF (ISET.EQ.1) THEN
                WRITE (6,'(10X,A)')'SCHULER-SJOSTRAND PHOTON PDF SET 1D'
              ELSEIF (ISET.EQ.2) THEN
                WRITE (6,'(10X,A)')'SCHULER-SJOSTRAND PHOTON PDF SET 1M'
              ELSEIF (ISET.EQ.3) THEN
                WRITE (6,'(10X,A)')'SCHULER-SJOSTRAND PHOTON PDF SET 2D'
              ELSEIF (ISET.EQ.4) THEN
                WRITE (6,'(10X,A)')'SCHULER-SJOSTRAND PHOTON PDF SET 2M'
              ELSE
                WRITE (6,'(10X,A)')'UNKNOWN SCHULER-SJOSTRAND PDF SET'
                CALL HWWARN('HWUINC',500,*999)
              ENDIF
              IF (IOP1.EQ.1) THEN
                WRITE (6,'(10X,A)') 'WITH DIRECT COMPONENT IN DIS'
                IF (IPRO.NE.90) WRITE (6,'(10X,A)')
     $               'NOT RECOMMENDED FOR NON-DIS PROCESSES'
              ENDIF
              IF (IOP2.EQ.1) THEN
                WRITE (6,'(10X,A)') 'WITH P**2 DEPENDENCE INCLUDED'
                IF (PHOMAS.GT.ZERO)
     $          WRITE (6,'(10X,A)') 'NOT RECOMMENDED WITH PHOMAS.GT.0'
                IF (IP2.GT.0)
     $          WRITE (6,'(10X,A,I2)') 'WITH IP2 OPTION EQUAL TO',IP2
              ENDIF
            ELSEIF (AUTPDF(I).EQ.'SSph') THEN
              WRITE (6,'(10X,A)') 'THE ACRONYM FOR SCHULER-SJOSTRAND'
              WRITE (6,'(10X,A)') 'HAS CHANGED TO SaSph ACCORDING TO'
              WRITE (6,'(10X,A)') 'THEIR WISHES.  SSph NO LONGER WORKS'
              STOP
            ELSE
              CALL PDFSET(PARM,VAL)
              CALL STRUCTM(X,QSCA,UPV,DNV,USEA,DSEA,STR,CHM,BTM,TOP,GLU)
            ENDIF
          ENDIF
 460    CONTINUE
        WRITE (6,'(1X)')
      ENDIF
C Set up neutral B meson mixing parameters
      IF (MIXING.AND..NOT.(RSTAB(223).AND.RSTAB(247))) THEN
        XMRCT(1)=XMIX(1)*RMASS(223)/(CSPEED*RLTIM(223))
        YMRCT(1)=YMIX(1)*RMASS(223)/(CSPEED*RLTIM(223))
      ENDIF
      IF (MIXING.AND..NOT.(RSTAB(221).AND.RSTAB(245))) THEN
        XMRCT(2)=XMIX(2)*RMASS(221)/(CSPEED*RLTIM(221))
        YMRCT(2)=YMIX(2)*RMASS(221)/(CSPEED*RLTIM(221))
      ENDIF
C---B DECAY PACKAGE
      IF (BDECAY.EQ.'EURO') THEN
        IF (IPRINT.NE.0) WRITE (6,470) 'EURODEC'
      ELSEIF (BDECAY.EQ.'CLEO') THEN
        IF (IPRINT.NE.0) WRITE (6,470) 'CLEO'
      ELSE
        BDECAY='HERW'
      ENDIF
  470 FORMAT (10X,A,' B DECAY PACKAGE WILL BE USED')
C---TAU DECAY PACKAGE
      IF(TAUDEC.EQ.'TAUOLA') THEN
        IF(IPRINT.NE.0) WRITE(6,475) 'TAUOLA'
        CALL HWDTAU(-1,0,0.0D0)
      ENDIF
  475 FORMAT(10X,A,' TAU DECAY PACKAGE WILL BE USED'/)
C---COMPUTE PARTICLE PROPERTIES FOR HADRONIZATION
      CALL HWURES
C Prepare internal decay tables and do diagnostic checks
      CALL HWUDKS
C Convert ampersands to backslahes in particle LaTeX names
      CALL HWUATS
C---MISCELLANEOUS DERIVED QUANTITIES
      TMTOP=2.*LOG(RMASS(6)/30.)
      PXRMS=PTRMS/SQRT(2.)
      ZBINM=0.25/ZBINM
      PSPLT(1)=1./PSPLT(1)
      PSPLT(2)=1./PSPLT(2)
      NDTRY=2*NCTRY
      NGSPL=0
      PGSMX=0.
      DO 480 I=1,4
      PGS=HWUPCM(RMASS(13),RMASS(I),RMASS(I))
      IF (PGS.GE.ZERO) NGSPL=I
      IF (PGS.GE.PGSMX) PGSMX=PGS
  480 PGSPL(I)=PGS
      CALL HWVZRO(6,PTINT)
      IF (IPRO.NE.80) THEN
C---SET UP TABLES OF SUDAKOV FORM FACTORS, GIVING
C   PROBABILITY DISTRIBUTION IN VARIABLE Q = E*SQRT(XI)
        NSUD=NFLAV
        CALL HWBSUD
C---SET PARAMETERS FOR SPACELIKE BRANCHING
        DO 500 I=1,NSUD
        DO 490 J=2,NQEV
        IF (QEV(J,I).GT.QSPAC) GOTO 500
  490   CONTINUE
  500   NSPAC(I)=J-1
      ENDIF
      EVWGT=AVWGT
      ISTAT=1
C--optimize the weights for the channels if needed
      CALL HWIPHS(2)
C--perform the initialisation of the SUSY ME's
      IF(SYSPIN.OR.THREEB.OR.FOURB) THEN
        CALL HWISPN
        IF (IPRINT.NE.0) WRITE (6,510)
 510    FORMAT(/10X,'CHECKING SUSY DECAY MATRIX ELEMENTS')
      ENDIF
C Print particle decay tables here
      IF (IPRINT.GE.2) CALL HWUDPR
C--   initialise photos if needed
      IF ((TAUDEC.EQ.'TAUOLA'.AND.IFPHOT.EQ.1).OR.ITOPRD.EQ.1)
     &     CALL PHOINI
  999 END
CDECK  ID>, HWUINE.
*CMZ :-        -16/10/93  12.42.15  by  Mike Seymour
*-- Author :    Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWUINE
C-----------------------------------------------------------------------
C     INITIALISES AN EVENT
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWRGEN,HWRGET,DUMMY
      REAL TL
      LOGICAL CALLED,HWRLOG
      EXTERNAL HWRGEN,HWRGET,HWRLOG
      COMMON/HWDBUG/CALLED
C---CHECK THAT MAIN PROGRAM HAS BEEN MODIFIED CORRECTLY
      IF (NEVHEP.GT.0.AND..NOT.CALLED) THEN
        WRITE (6,10)
 10     FORMAT (1X,'A call to the subroutine HWUFNE should be added to',
     &      /,' the main program, immediately after the call to HWMEVT')
        CALL HWWARN('HWUINE',500,*999)
      ENDIF
      CALLED=.FALSE.
C---CHECK TIME LEFT
      CALL HWUTIM(TL)
      IF (TL.LT.TLOUT) CALL HWWARN('HWUINE',200,*999)
C---UPDATE RANDOM NUMBER SEED
      DUMMY = HWRGET(NRN)
      NEVHEP=NEVHEP+1
      IF (NEGWTS.AND.EVWGT.LT.ZERO) NNEGEV=NNEGEV+1
      NHEP=0
      ISTAT=6
      IERROR=0
      EVWGT=AVWGT
      HVFCEN=.FALSE.
      ISLENT=1
      NQDK=0
C---DECIDE WHETHER TO GENERATE SOFT UNDERLYING EVENT
      GENSOF=IPROC.GE.1300.AND.IPROC.LT.10000.AND.
     &      (IPROC.EQ.8000.OR.HWRLOG(PRSOF))
C Zero arrays
      CALL HWVZRI(2*NMXHEP,JMOHEP)
      CALL HWVZRI(2*NMXHEP,JDAHEP)
      CALL HWVZRO(4*NMXHEP,VHEP)
      CALL HWVZRO(3*NMXHEP,RHOHEP)
      EMSCA=ZERO
      IF(SYSPIN) THEN
        NSPN = 0
        CALL HWVZRI(  NMXHEP,ISNHEP)
        CALL HWVZRI(  NMXSPN,JMOSPN)
        CALL HWVZRI(2*NMXSPN,JDASPN)
        CALL HWVZRI(  NMXSPN, IDSPN)
      ENDIF
  999 END
CDECK  ID>, HWULB4.
*CMZ :-        -05/11/95  19.33.42  by  Mike Seymour
*-- Author :    Adapted by Bryan Webber
C-----------------------------------------------------------------------
      SUBROUTINE HWULB4(PS,PI,PF)
C-----------------------------------------------------------------------
C     TRANSFORMS PI (GIVEN IN REST FRAME OF PS) INTO PF (IN LAB)
C     N.B. P(1,2,3,4) = (PX,PY,PZ,E); PS(5)=M
C-----------------------------------------------------------------------
      DOUBLE PRECISION PF4,FN,PS(5),PI(4),PF(4)
      IF (PS(4).EQ.PS(5)) THEN
        PF(1)= PI(1)
        PF(2)= PI(2)
        PF(3)= PI(3)
        PF(4)= PI(4)
      ELSE
        PF4  = (PI(1)*PS(1)+PI(2)*PS(2)
     &         +PI(3)*PS(3)+PI(4)*PS(4))/PS(5)
        FN   = (PF4+PI(4)) / (PS(4)+PS(5))
        PF(1)= PI(1) + FN*PS(1)
        PF(2)= PI(2) + FN*PS(2)
        PF(3)= PI(3) + FN*PS(3)
        PF(4)= PF4
      END IF
      END
