
       SUBROUTINE runmcarlo(IRUN, ierr)

C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003


      include "../mcarlo/inc/jetset74.inc"
      include "../mcarlo/inc/lepto65.inc"
      include "../inc/hepevt_pythia57.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"
 
      Integer I, J, N, nev, IPOSI
      Real pbeam(4), ebeam(4) 
      Integer IRUN,ierr,IPAR
      Save nev 

      goto (1000, 2000, 3000) IRUN
      return

*      IF (IRUN.eq.0) GOTO 100
*      IF (IRUN.eq.1) GOTO 200
*      IF (IRUN.eq.2) GOTO 300

 1000   CONTINUE 


       write(6,*)'initialisation of LEPTO 6.5 by RUNMC '
       CALL LUGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL LUGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
       write(6,*)PARJ(72),'mm maximum distance a decay is allowed'

C set seed number
      MRLU(1)=RUNMCseed1+RUNMCseed2
      write(6,*) "LEPTO 6.5: new seed for this run = ",MRLU(1)

*-take positron (default) 
       IPOSI=-11
       nev=0
       ierr=1
       xCross=0.
       eCross=0.

       CUT(1)=rXbj(2)  ! min X
       CUT(2)=rXbj(3)  ! max X
       CUT(3)=rYbj(2)  ! min Y 
       CUT(4)=rYbj(3)  ! max Y 
       CUT(5)=rQ2(2)  ! min Q2
       CUT(6)=rQ2(3)  ! max Q2
C       CUT(7)=rW(2)*rW(2)   ! min W2 
C       CUT(8)=rW(3)*rW(3)   ! max W2


        LST(16)=2
        LST(18)=4
        IF (PDF1.eq.1.or.PDF2.eq.1)  LST(15)=4046 ! CTEQ5 LO 
        IF (PDF1.eq.2.or.PDF2.eq.2)  LST(15)=3072 ! MRST c-g LO
        IF (PDF1.eq.3.or.PDF2.eq.3)  LST(15)=5012 ! GRV 98 LO
                    
* redefine initial lepton  
        IF (abs(PID1).le.14) THEN
             IPOSI=PID1
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER1
             ebeam(4)=ENER1
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER2
           pbeam(4)=ENER2
         ENDIF
 
       IF (abs(PID2).le.14) THEN
             IPOSI=PID2
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER2
             ebeam(4)=ENER2
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER1
           pbeam(4)=ENER1
         ENDIF


C set parameters via cards
         Call RunMC_Steer("lepto65.cards")
         Call RUNMCleptosteer

C set user intialization
         Call setLEPTO65

*         write(6,*) 'Lepton energy:'
*         write(6,*) 'ebeam(1)=',ebeam(1)
*         write(6,*) 'ebeam(2)=',ebeam(2)
*         write(6,*) 'ebeam(3)=',ebeam(3)
*         write(6,*) 'ebeam(4)=',ebeam(4) 
*         write(6,*) 'Proton energy:'
*         write(6,*) 'pbeam(1)=',pbeam(1)
*         write(6,*) 'pbeam(2)=',pbeam(2)
*         write(6,*) 'pbeam(3)=',pbeam(3)
*         write(6,*) 'pbeam(4)=',pbeam(4)
*         write(6,*) (CUT(i),i=1,8)


C...Initialize LEPTO for HERA
       CALL LINIT(0,IPOSI,ebeam(3),pbeam(3),4)

       write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

C...Call generate an event with LEPTO
        CALL LEPTO
        IF (LST(21).ne.0) THEN
         NHEP=-1
         goto 9999
        ENDIF

        nev=nev+1
C copy kinematic varaibles
        ierr=0        
        rQ2(1)=Q2
        rXbj(1)=X
        rYbj(1)=Y 
        rW(1)=sqrt(W2)
         
C.. convert from JETSET common
        CALL LUHEPC(1)
C...Call a user supplied analysis routine
        if (nev.le.5)  CALL LULIST(1) 

C to check  
C        write(6,*) ' ' 
C        write(6,*) 'Total number in HEPEVT=',NHEP 
C        do i=1,NHEP
C        write(6,*) i, IDHEP(i),PHEP(1,i),PHEP(2,i),PHEP(3,i) 
C        enddo 

 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

      xCross=PARL(24)
      eCross=0
      write(6,*) 'Cross section in pb',xCross
      write(6,*) 'RUNMC-lepto: ALL done!'

      RETURN      
      END  
 
