C
C
      SUBROUTINE DATESS
C**********************************************************************
C
C     output of all particle and decay constants
C
C     ATTENTION: changed to work with new decay data (01/95)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      CHARACTER*8 ZKNAME,ANAME,Z
      COMMON/DECAYC/ ZKNAME(550),NZK(550,3),WT(550)
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
      COMMON /HAMCIN/IAMCIN(187)
      DIMENSION ICHAR(187)
      EQUIVALENCE (ICH(1),ICHAR(1))
      DIMENSION Z(3)
C
      PRINT 102
  102 FORMAT(///' TABLE OF USED PARTICLES AND RESONANCES (I)',//
     *' I = NUMBER OF PARTICLE OR RESONANCE',/
     *' IAMCIN = PARTICLE DATA GROUP INDEX OF PARTICLE OR RESONANCE',/
     *' ANAME = NAME OF I'/,
     *' AM = MASS OF I  (GEV)',/
     *' GA = WIDTH OF I  (GEV)',/
     *' TAU = LIFE TIME OF I  (SEC.)',/
     *' ICH = ELECTRIC CHARGE OF I, IBAR = BARYONIC CHARGE OF I',/' ', '
     *K1 = FIRST DECAY CHANNEL NUMBER, K2 = LAST DECAY CHANNEL NUMBER OF
     *I')
      PRINT 101
  101 FORMAT(///'   I  PDG-I  ANAME     AM         GA         TAU
     &ICH IBAR  K1  K2'/)
      JOO=180
      DO 41 I=1,JOO
      PRINT 100,I,IAMCIN(I),ANAME(I),AM(I),GA(I),TAU(I),ICH(I),
     *            IBAR(I),K1(I),K2(I)
  100 FORMAT (1I4,I7,2X,A8,3E11.4,4I4)
   41 CONTINUE
      PRINT 92
   92 FORMAT(///' DECAY CHANNELS OF PARTICLES AND RESONANCES',//)
      PRINT 93
   93 FORMAT(' ANAME = PARTICLE AND RESONANCE NAME'/,
     *' DNAME = DECAY CHANNEL NAME'/,
     *' J = DECAY CHANNEL NUMBER'/,
     *' I = NUMBER OF DECAYING PARTICLE'/,
     *' WT = SUM OF DECAY CHANNEL WEIGHTS FROM K1(I) UP TO J'/,
     *' NZK = PROGRAM INTERNAL NUMBERS OF DECAY PRODUCTS')
      PRINT 94
   94 FORMAT(///'   I     J      ANAME       DNAME                DECAY
     *PRODUCTS            WT       NZK'/)
      DO 2 I=1,JOO
        IK1=K1(I)
        IK2=K2(I)
        IF (IK1.LE.0) GO TO 2
        WTSUM = 0.D0
        DO 3 IK=IK1,IK2
          WTSUM  = WTSUM+WT(IK)
          I1=NZK(IK,1)
          I2=NZK(IK,2)
          I3=NZK(IK,3)
          AMTEST=AM(I)
          IBTEST=IBAR(I)
          ICTEST=ICHAR(I)
          Z(1) = 'BLANC   '
          Z(2) = 'BLANC   '
          Z(3) = 'BLANC   '
          IF (I1.GT.0) THEN
            Z(1)=ANAME(I1)
            AMTEST = AMTEST-AM(I1)
            IBTEST = IBTEST-IBAR(I1)
            ICTEST = ICTEST-ICH(I1)
          ENDIF
          IF (I2.GT.0) THEN
            Z(2)=ANAME(I2)
            AMTEST = AMTEST-AM(I2)
            IBTEST = IBTEST-IBAR(I2)
            ICTEST = ICTEST-ICH(I2)
          ENDIF
          IF (I3.GT.0) THEN
            Z(3)=ANAME(I3)
            AMTEST = AMTEST-AM(I3)
            IBTEST = IBTEST-IBAR(I3)
            ICTEST = ICTEST-ICH(I3)
          ENDIF
      PRINT 91,I,IK,ANAME(I),ZKNAME(IK),(Z(J),J=1,3),WT(IK),I1,I2,I3
   91 FORMAT(2I5,' DECAY OF ',1A6,' (CHANNEL: ',1A6,' ) TO ',3(1A6,2X),
     *1F8.4,3I5)
      IF (AMTEST) 51,52,52
   51 MTEST=1
      GO TO 53
   52 MTEST=0
   53 CONTINUE
      IF (MTEST+IBTEST**2+ICTEST**2.NE.0) PRINT 909,AMTEST,IBTEST,ICTEST
  909 FORMAT (' DATESS:WARNING: DECAY VALUES (MA,BA,CH)',F10.5,2I6)
    3 CONTINUE
      IF(ABS(WTSUM-1.D0).GT.1.D-10)
     &  WRITE(6,'(1X,A,F10.7)') 'DATESS:ERROR: WEIGHT SUM',WTSUM
    2 CONTINUE
      RETURN
      END
