      SUBROUTINE PHOINP(LINP,IREJ,NN1,NN2,NN3,NN4)
C**********************************************************************
C
C     main subroutine to configure and manage PHOJET calculations
C
C     input:  LINP       input unit to read from
C                        -1 to skip reading of input file
C
C     output: IREJ       0  success
C                        1  failure
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
C
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
      COMMON /HAGAUP/ NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
      COMMON /HADRON/ QMASS(6),BET,PCOUDI,PNORM,VALPRG(2),NFS
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
      COMMON /LEPCUT/ ECMIN,ECMAX,EEMIN1,EEMIN2,
     &                YMIN1,YMAX1,YMIN2,YMAX2,
     &                Q2MIN1,Q2MAX1,Q2MIN2,Q2MAX2,
     &                THMIN1,THMAX1,THMIN2,THMAX2
C
      PARAMETER(IEETAB=20,IIMAX=30,KKMAX=10)
      REAL PROB
      COMMON /PROBAB/ PROB(4,IEETAB,0:IIMAX,0:KKMAX),EPTAB(4,IEETAB),
     &                IEEMAX,IMAX,KMAX
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER ( MAXPRO = 16 )
      CHARACTER*18 PROC
      COMMON /PEPROC/ PROC(0:MAXPRO)
      PARAMETER ( MAXTAB = 20 )
      COMMON /HAXSEC/ XSECTA(4,-1:MAXPRO,4,MAXTAB),XSECT(6,-1:MAXPRO),
     &                MXSECT(0:4,-1:MAXPRO,4),ECMSH(4,MAXTAB),ISTTAB
      COMMON /INPUTS/ PARINP(30)
C
C  LUND variables
**sr 29.04. commented to use dp-JETSET
      REAL  PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
**sr 29.04. commented to use dp-JETSET
      REAL  PMAS,PARF,VCKM
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
**sr 29.04. commented to use dp-JETSET
      REAL  BRAT
      COMMON/LUDAT3/MDCY(500,3),MDME(2000,2),BRAT(2000),KFDP(2000,5)
C
      PARAMETER(IZERO = 0,
     &          ONE   = 1.D0,
     &          ZERO  = 0.D0)
      PARAMETER(NTABM=50)
      COMPLEX*16 DSIGHC,DSIGH
      DIMENSION DSIGH(0:MAXPRO),DSIGHC(0:MAXPRO),XTA(6,NTABM)
      DIMENSION DSPT(0:MAXPRO)
      CHARACTER*10 CNAME
      CHARACTER*70 NUMBER
C
 14   FORMAT(A10,A69)
 15   FORMAT(A12)
      IREJ = 0
      WRITE(6,*)
      WRITE(6,*) ' ==================================================='
      WRITE(6,*) '  ----------- PHOJET v.1.05c(04-Jun-96) -----------'
      WRITE(6,*) ' ==================================================='
      WRITE(6,*) '       please send suggestions / bug reports to:'
      WRITE(6,*) '     eng@tph200.physik.uni-leipzig.de (Ralph Engel)'
      WRITE(6,*) ' ==================================================='
      WRITE(6,*)
C
C  random numbers
      CALL RNDMST(NN1,NN2,NN3,NN4)
      CALL RNDMTE(0)
C  standard initializations
      CALL PHODAT
      CALL HADDAT
      CALL FITDAT
      DUMMY = POPAMA(0,-1)
C  initialize standard PDFs
C  proton
      CALL SETPDF(2212,IDUM,5,6,0,0,-1)
      CALL SETPDF(-2212,IDUM,5,6,0,0,-1)
C  neutron
      CALL SETPDF(2112,IDUM,5,6,0,0,-1)
      CALL SETPDF(-2112,IDUM,5,6,0,0,-1)
C  photon
      CALL SETPDF(22,IDUM,5,3,0,0,-1)
C  pomeron
      CALL SETPDF(45,IDUM,4,0,0,0,-1)
C  pion
      CALL SETPDF(211,IDUM,5,2,0,0,-1)
      CALL SETPDF(-211,IDUM,5,2,0,0,-1)
      CALL SETPDF(111,IDUM,5,2,0,0,-1)
C
C  no file to read
      IF(LINP.LT.0) RETURN
C
C  main loop to read input cards
 1200 CONTINUE
        READ(LINP,14,END=1300) CNAME,NUMBER
        IF(CNAME.EQ.'ENDINPUT  ') THEN
          GOTO 1300
        ELSE IF(CNAME.EQ.'STOP      ') THEN
          WRITE(6,*) 'STOP'
          STOP
        ELSE IF(CNAME.EQ.'COMMENT   ') THEN
          WRITE(6,'(1X,A10,A69)') 'COMMENT   ',NUMBER
        ELSE IF(CNAME(1:1).EQ.'*') THEN
          WRITE(6,'(1X,A10,A69)') CNAME,NUMBER
        ELSE IF(CNAME.EQ.'PTCUT     ') THEN
          READ(NUMBER,*) PARMDL(36),PARMDL(37),PARMDL(38),PARMDL(39)
          WRITE(6,*) 'PTCUT     ',PARMDL(36),PARMDL(37),
     &      PARMDL(38),PARMDL(39)
        ELSE IF(CNAME.EQ.'MASSCUT   ') THEN
          READ(NUMBER,*) CUTMU
          WRITE(6,*) 'MASSCUT   ',CUTMU
        ELSE IF(CNAME.EQ.'PROCESS   ') THEN
          READ(NUMBER,*) (IPRON(KK),KK=1,11)
          WRITE(6,*) 'PROCESS   ',(IPRON(KK),KK=1,11)
        ELSE IF(CNAME.EQ.'SUBPROCESS') THEN
          READ(NUMBER,*) IMPRO,IP,ION
          WRITE(6,*) 'SUBPROCESS',IMPRO,IP,ION
          MXSECT(0,IMPRO,IP) = ION
        ELSE IF(CNAME.EQ.'PARTICLE1 ') THEN
          READ(NUMBER,*) IDPDG,PVIR
          CALL SETPAR(1,IDPDG,0,PVIR)
          WRITE(6,*) 'PARTICLE1  ',IDPDG,PVIR
        ELSE IF(CNAME.EQ.'PARTICLE2 ') THEN
          READ(NUMBER,*) IDPDG,PVIR
          CALL SETPAR(2,IDPDG,0,PVIR)
          WRITE(6,*) 'PARTICLE2  ',IDPDG,PVIR
        ELSE IF(CNAME.EQ.'REMNANT1  ') THEN
          READ(NUMBER,*) IDPDG,IFL1,IFL2,PVIR
          IHFLS(1) = 0
          IHFLD(1,1) = IFL1
          IHFLD(1,2) = IFL2
          CALL SETPAR(1,IDPDG,-1,PVIR)
          WRITE(6,*) 'REMNANT1   ',IDPDG,IFL1,IFL2,PVIR
        ELSE IF(CNAME.EQ.'REMNANT2  ') THEN
          READ(NUMBER,*) IDPDG,IFL1,IFL2,PVIR
          IHFLS(2) = 0
          IHFLD(2,1) = IFL1
          IHFLD(2,2) = IFL2
          CALL SETPAR(2,IDPDG,-1,PVIR)
          WRITE(6,*) 'REMNANT2   ',IDPDG,IFL1,IFL2,PVIR
        ELSE IF(CNAME.EQ.'PDF       ') THEN
          READ(NUMBER,*) IDPDG,IPAR,ISET,IEXT
          WRITE(6,*) 'PDF        ',IDPDG,IPAR,ISET,IEXT
          CALL SETPDF(IDPDG,IDUM,IPAR,ISET,IEXT,0,-1)
        ELSE IF(CNAME.EQ.'SETMODEL  ') THEN
          READ(NUMBER,*) I,IVAL
          WRITE(6,*) 'SETMODEL   ',I,IVAL
          CALL SETMDL(I,IVAL,1)
        ELSE IF(CNAME.EQ.'SETPARAM  ') THEN
          READ(NUMBER,*) I,PARNEW
          WRITE(6,*) 'SETPARAM   ',I,PARNEW
          PARMDL(I) = PARNEW
        ELSE IF(CNAME.EQ.'LUND-MSTU ') THEN
          READ(NUMBER,*) I,IVAL
          WRITE(6,*) 'LUND-MSTU  ',I,IVAL
          MSTU(I) = IVAL
        ELSE IF(CNAME.EQ.'LUND-MSTJ ') THEN
          READ(NUMBER,*) I,IVAL
          WRITE(6,*) 'LUND-MSTJ  ',I,IVAL
          MSTJ(I) = IVAL
        ELSE IF(CNAME.EQ.'LUND-PARJ ') THEN
          READ(NUMBER,*) I,EE
          WRITE(6,*) 'LUND-PARJ  ',I,EE
          PARJ(I) = REAL(EE)
        ELSE IF(CNAME.EQ.'LUND-PARU ') THEN
          READ(NUMBER,*) I,EE
          WRITE(6,*) 'LUND-PARU  ',I,EE
          PARU(I) = REAL(EE)
        ELSE IF(CNAME.EQ.'LUND-DECAY') THEN
          READ(NUMBER,*) ID,ION
          WRITE(6,*) 'LUND-DECAY ',ID,ION
          KC=LUCOMP(ID)
          MDCY(KC,1) = ION
        ELSE IF(CNAME.EQ.'PSOFTMIN  ') THEN
          READ(NUMBER,*) PSOMIN
          WRITE(6,*) 'PSOFTMIN   ',PSOMIN
        ELSE IF(CNAME.EQ.'ALPOM     ') THEN
          READ(NUMBER,*) PARINP(1)
          WRITE(6,*) 'ALPOM      ',PARINP(1)
        ELSE IF(CNAME.EQ.'ALPOMP    ') THEN
          READ(NUMBER,*) PARINP(2)
          WRITE(6,*) 'ALPOMP     ',PARINP(2)
        ELSE IF(CNAME.EQ.'GP1        ') THEN
          READ(NUMBER,*) PARINP(3)
          WRITE(6,*) 'GP1        ',PARINP(3)
        ELSE IF(CNAME.EQ.'GP2        ') THEN
          READ(NUMBER,*) PARINP(4)
          WRITE(6,*) 'GP2        ',PARINP(4)
        ELSE IF(CNAME.EQ.'B0POM1    ') THEN
          READ(NUMBER,*) PARINP(5)
          WRITE(6,*) 'B0POM1     ',PARINP(5)
        ELSE IF(CNAME.EQ.'B0POM2    ') THEN
          READ(NUMBER,*) PARINP(6)
          WRITE(6,*) 'B0POM2     ',PARINP(6)
        ELSE IF(CNAME.EQ.'ALREG     ') THEN
          READ(NUMBER,*) PARINP(7)
          WRITE(6,*) 'ALREG      ',PARINP(7)
        ELSE IF(CNAME.EQ.'ALREGP    ') THEN
          READ(NUMBER,*) PARINP(8)
          WRITE(6,*) 'ALREGP     ',PARINP(8)
        ELSE IF(CNAME.EQ.'GR1       ') THEN
          READ(NUMBER,*) PARINP(9)
          WRITE(6,*) 'GR1        ',PARINP(9)
        ELSE IF(CNAME.EQ.'GR2       ') THEN
          READ(NUMBER,*) PARINP(10)
          WRITE(6,*) 'GR2        ',PARINP(10)
        ELSE IF(CNAME.EQ.'B0REG1    ') THEN
          READ(NUMBER,*) PARINP(11)
          WRITE(6,*) 'B0REG1     ',PARINP(11)
        ELSE IF(CNAME.EQ.'B0REG2    ') THEN
          READ(NUMBER,*) PARINP(12)
          WRITE(6,*) 'B0REG2     ',PARINP(12)
        ELSE IF(CNAME.EQ.'GPPP      ') THEN
          READ(NUMBER,*) PARINP(13)
          WRITE(6,*) 'GPPP       ',PARINP(13)
        ELSE IF(CNAME.EQ.'GPPR      ') THEN
          READ(NUMBER,*) PARINP(27)
          WRITE(6,*) 'GPPR       ',PARINP(27)
        ELSE IF(CNAME.EQ.'B0PPP     ') THEN
          READ(NUMBER,*) PARINP(14)
          WRITE(6,*) 'B0PPP      ',PARINP(14)
        ELSE IF(CNAME.EQ.'B0PPR     ') THEN
          READ(NUMBER,*) PARINP(28)
          WRITE(6,*) 'B0PPP      ',PARINP(28)
        ELSE IF(CNAME.EQ.'VDMFAC    ') THEN
          READ(NUMBER,*) PARINP(15),PARINP(16),PARINP(17),PARINP(18)
          WRITE(6,*) 'VDMFAC     ',
     &                   PARINP(15),PARINP(16),PARINP(17),PARINP(18)
        ELSE IF(CNAME.EQ.'B0HAR     ') THEN
          READ(NUMBER,*) PARINP(19)
          WRITE(6,*) 'B0HAR      ',PARINP(19)
        ELSE IF(CNAME.EQ.'AKFAC     ') THEN
          READ(NUMBER,*) PARINP(20)
          WRITE(6,*) 'AKHAR      ',PARINP(20)
        ELSE IF(CNAME.EQ.'PHISUP1   ') THEN
          READ(NUMBER,*) PARINP(21)
          WRITE(6,*) 'PHISUP1    ',PARINP(21)
        ELSE IF(CNAME.EQ.'PHISUP2   ') THEN
          READ(NUMBER,*) PARINP(22)
          WRITE(6,*) 'PHISUP2    ',PARINP(22)
        ELSE IF(CNAME.EQ.'RMASS1    ') THEN
          READ(NUMBER,*) PARINP(23)
          WRITE(6,*) 'RMASS1     ',PARINP(23)
        ELSE IF(CNAME.EQ.'RMASS2    ') THEN
          READ(NUMBER,*) PARINP(24)
          WRITE(6,*) 'RMASS2     ',PARINP(24)
        ELSE IF(CNAME.EQ.'VAR       ') THEN
          READ(NUMBER,*) PARINP(25)
          WRITE(6,*) 'VAR        ',PARINP(25)
        ELSE IF(CNAME.EQ.'INTPREC   ') THEN
          READ(NUMBER,*) NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
          WRITE(6,*) 'INTPREC    ',NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
        ELSE IF(CNAME.EQ.'BEGINFIT  ') THEN
          CALL PHOFIT
        ELSE IF(CNAME.EQ.'DEBUG     ') THEN
          READ(NUMBER,*) IDEBF,IDEBN,IDLEV
          WRITE(6,*) 'DEBUG      ',IDEBF,IDEBN,IDLEV
          CALL TRACE(IDEBF,IDEBN,IDLEV)
        ELSE IF(CNAME.EQ.'TRACE     ') THEN
          READ(NUMBER,*) IDEBF,IDLEV
          WRITE(6,*) 'TRACE      ',IDEBF,IDLEV
          IDEB(IDEBF) = IDLEV
C
C*** test run to produce output table of cross sections
        ELSE IF(CNAME.EQ.'HARDTABLE1') THEN
          READ(NUMBER,*) ELOWER,EUPPER,FAC,NSTEP
          WRITE(6,*)
     &    ' **** start of energy table ****'
          WRITE(6,*) '  E_min = ',ELOWER
          WRITE(6,*) '  E_max = ',EUPPER
          WRITE(6,*) ' factor = ',FAC
          WRITE(6,*) '  steps = ',NSTEP
          CALL FITPAR(1)
          WRITE(6,*) ' TABLE: DSIGh(ECM) (mb) times scaling factor'
          WRITE(6,*)
     & ' ECM   SUM  2RES-ALL  1RES+DIR-ALL  1RES-1  1RES-ALL  SIGDIR'
          WRITE(6,*)
     & ' ==========================================================='
          DELTA=(LOG(EUPPER)-LOG(ELOWER))/DBLE(NSTEP-1)
          ETAB=LOG(ELOWER)-DELTA
          DO 300 I=1,NSTEP
          ETAB=ETAB+DELTA
          ECM=EXP(ETAB)
          CALL POHINT(1,ECM,0,-2,0,0,1)
          CALL POHXTO(ECM,PTCUT(1),PTCUT(1),DSIGHC,DSPT)
          WRITE(6,'(1X,7E11.4)')
     &      ECM,DREAL(DSIGHC(0))*FAC,DREAL(DSIGHC(9))*FAC,
     &      DREAL(DSIGHC(15))*FAC,DREAL(DSIGHC(10)+DSIGHC(11))*FAC,
     &      DREAL(DSIGHC(10)+DSIGHC(11)+DSIGHC(12)+DSIGHC(13))*FAC,
     &      DREAL(DSIGHC(14))*FAC
 300      CONTINUE
          WRITE(6,*) ' ----------------------------------------------'
          WRITE(6,*)
     &    ' **** end of energy table ****'
C
C  calculate table SIGH(PT)
        ELSE IF(CNAME.EQ.'HARDTABLE2') THEN
          READ(NUMBER,*) ECM,PTMIN,PTMAX,FAC,NSTEP
          WRITE(6,*)
     &    ' **** start of hard input cross section table ****'
          WRITE(6,*) '  Ecm    = ',ECM
          WRITE(6,*) '  pt_min = ',PTMIN
          WRITE(6,*) '  pt_max = ',PTMAX
          WRITE(6,*) '  factor = ',FAC
          WRITE(6,*) '  steps = ',NSTEP
          CALL FITPAR(1)
          WRITE(6,*) ' -----------------------------------------------'
          CALL POHINT(1,ECM,0,-2,0,0,1)
          DELTA=(PTMAX-PTMIN)/DBLE(NSTEP-1)
          WRITE(6,'(3(/4X,A))')
     &      'TABLE: SIGh(PT)  (mb)',
     &      'PT     TOT.SUM    RES.SUM   DIR.SUM   DIRECT(10, 11, 14)',
     &      '========================================================='
          DO 102 I=1,NSTEP
            PTCUT(1) = PTMIN+DBLE(I-1)*DELTA
            CALL POHXTO(ECM,PTCUT(1),PTCUT(1),DSIGH,DSPT)
            WRITE(6,'(1X,7E11.4)')
     &        PTCUT(1),DREAL(DSIGH(0))*FAC,DREAL(DSIGH(9))*FAC,
     &        DREAL(DSIGH(15))*FAC,DREAL(DSIGH(10))*FAC,
     &        DREAL(DSIGH(11))*FAC,DREAL(DSIGH(14))*FAC
 102      CONTINUE
          WRITE(6,*) ' -----------------------------------------------'
          WRITE(6,*)
     &    ' **** end of hard input cross section table ****'
C
C  calculate SIGH(PT) for all hard scattering processes
        ELSE IF(CNAME.EQ.'HARDTABLE3') THEN
          READ(NUMBER,*) ECM,PTMIN,FAC
          WRITE(6,*)
     &    ' **** start of hard input cross section table ****'
          WRITE(6,*) '  Ecm    = ',ECM
          WRITE(6,*) '  pt_cut = ',PTMIN
          WRITE(6,*) '  factor = ',FAC
          CALL FITPAR(1)
          WRITE(6,'(2(/1X,A))') 
     &      ' NO    PROCESS          SIGH(PT) (REAL/IMAG)     DSIG/DPT',
     &      '========================================================='
          CALL POHINT(1,ECM,0,-2,0,0,1)
          PTCUT(1) = PTMIN
          CALL POHXTO(ECM,PTCUT(1),PTCUT(1),DSIGH,DSPT)
          DO 103 I=0,MAXPRO
            WRITE(6,'(2X,I3,2X,A,2E12.4,3X,E12.4)') 
     &        I,PROC(I),DSIGH(I)*FAC,DSPT(I)*FAC
 103      CONTINUE
          WRITE(6,*) ' -----------------------------------------------'
          WRITE(6,*)
C
C  calculate table DSIGH/DPT
        ELSE IF(CNAME.EQ.'PTTABLE   ') THEN
          READ(NUMBER,*) ECM,PTMIN,PTMAX,FAC,NSTEP
          WRITE(6,*)
     &    ' **** start of pt table ****'
          WRITE(6,*) '  Ecm    = ',ECM
          WRITE(6,*) '  pt_min = ',PTMIN
          WRITE(6,*) '  pt_max = ',PTMAX
          WRITE(6,*) '  factor = ',FAC
          WRITE(6,*) '  steps  = ',NSTEP
          CALL FITPAR(1)
          WRITE(6,*) ' -----------------------------------------------'
          CALL POHINT(1,ECM,0,-2,0,0,1)
          DELTA=(PTMAX-PTMIN)/DBLE(NSTEP-1)
          WRITE(6,'(3(/4X,A))')
     &      'TABLE: DSIGh/DPT  (mb/GeV) times scaling factor',
     &      '  PT  SUM  D-RES  S-RES1,2+DIR  S-RES-1 S-RES-ALL  SIGDIR',
     &      '========================================================='
          DO 100 I=1,NSTEP
            PT=PTMIN+DBLE(I-1)*DELTA
            CALL POHXPT(ECM,PT,3,DSIGH)
            WRITE(6,'(1X,7E11.4)')
     &        PT,DREAL(DSIGH(0))*FAC,DREAL(DSIGH(9))*FAC,
     &        DREAL(DSIGH(15))*FAC,DREAL(DSIGH(10)+DSIGH(11))*FAC,
     &        DREAL(DSIGH(10)+DSIGH(11)+DSIGH(11)+DSIGH(12))*FAC,
     &        DREAL(DSIGH(14))*FAC
 100      CONTINUE
          WRITE(6,*) ' -----------------------------------------------'
          WRITE(6,*)
     &    ' **** end of pt table ****'
C
C  calculate impact parameter amplitudes
        ELSE IF(CNAME.EQ.'IMPACTAMP ') THEN
          READ(NUMBER,*) EE,BMIN,BMAX,NSTEP
          WRITE(6,*)
     &    ' **** start of impact parameter amplitude table ****'
          WRITE(6,*) '  Ecm    = ',EE
          WRITE(6,*) '  B_min = ',BMIN
          WRITE(6,*) '  B_max = ',BMAX
          WRITE(6,*) '  steps = ',NSTEP
          CALL FITPAR(1)
          CALL IMPAMP(EE,BMIN,BMAX,NSTEP)
C
C  decay tables
        ELSE IF(CNAME.EQ.'DECAYTABLE') THEN
          READ(NUMBER,*) I
          WRITE(6,*) 'DECAYTABLE',I
          IF(I.LE.2) THEN
            CALL PRIBLO(I)
          ELSE
            CALL DATESS
          ENDIF
C
C  PDF test utility
        ELSE IF(CNAME.EQ.'PDFTEST   ') THEN
          READ(NUMBER,*) IDPDG,SCALE2,PVIRT2
          PVIRT2 = ABS(PVIRT2)
          WRITE(6,*) 'PDFTEST   ',IDPDG,' ',SCALE2,' ',PVIRT2
          CALL POSFTU(IDPDG,SCALE2,PVIRT2)
C
C  mass cut on gamma-gamma or gamma-hadron system
        ELSE IF(CNAME.EQ.'ECMS-CUT  ') THEN
          READ(NUMBER,*) ECMIN,ECMAX
          WRITE(6,*) 'ECMS-CUT  ',ECMIN,ECMAX
C
C  electron anti-tagging system
        ELSE IF(CNAME.EQ.'E-TAG1    ') THEN
          READ(NUMBER,*) EEMIN1,YMIN1,YMAX1,Q2MIN1,Q2MAX1,THMIN1,THMAX1
          WRITE(6,*) 'E-TAG1    ',EEMIN1,YMIN1,YMAX1,Q2MIN1,Q2MAX1,
     &      THMIN1,THMAX1
        ELSE IF(CNAME.EQ.'E-TAG2    ') THEN
          READ(NUMBER,*) EEMIN2,YMIN2,YMAX2,Q2MIN2,Q2MAX2,THMIN2,THMAX2
          WRITE(6,*) 'E-TAG2    ',EEMIN2,YMIN2,YMAX2,Q2MIN2,Q2MAX2,
     &      THMIN2,THMAX2
C
C  sampling of photoproduction events ep (HERA)
        ELSE IF(    (CNAME.EQ.'WW-HERA   ')
     &          .OR.(CNAME.EQ.'GP-HERA   ')) THEN
          READ(NUMBER,*) EE1,EE2,NEV
          WRITE(6,*) 'GP-HERA   ',EE1,EE2,NEV
          IF(YMAX2.LT.ZERO) THEN
            WRITE(6,*) ' PHOINP:ERROR:ELECTRON TAGGER NOT SET'
          ELSE
            CALL GPHERA(NEV,EE1,EE2)
            KEVENT = 0
          ENDIF
C
C  sampling of photoproduction events e+e-
        ELSE IF(    (CNAME.EQ.'GG-EPEM   ') 
     &          .OR.(CNAME.EQ.'WW-EPEM   ')) THEN
          READ(NUMBER,*) EE1,EE2,NEV
          WRITE(6,*) 'GG-EPEM   ',EE1,EE2,NEV
          IF((YMAX1.LT.ZERO).OR.(YMAX2.LT.ZERO)) THEN
            WRITE(6,*) ' PHOINP:ERROR:ELECTRON TAGGERS NOT SET'
          ELSE
            CALL GGEPEM(NEV,EE1,EE2)
            KEVENT = 0
          ENDIF
C
C  sampling of photoproduction in heavy-ion collisions
        ELSE IF(CNAME.EQ.'GG-HION-F ') THEN
          READ(NUMBER,*) EE,NA,NZ,NEV
          WRITE(6,*) 'GG-HION-F ',EE,NA,NZ,NEV
          IF((YMAX1.LT.ZERO).OR.(YMAX2.LT.ZERO)) THEN
            WRITE(6,*) ' PHOINP:ERROR:Y RANGE FOR PHOTONS NOT SET'
          ELSE
            CALL GGHIOF(NEV,EE,NA,NZ)
            KEVENT = 0
          ENDIF
        ELSE IF(CNAME.EQ.'GG-HION-G ') THEN
          READ(NUMBER,*) EE,NA,NZ,NEV
          WRITE(6,*) 'GG-HION-G ',EE,NA,NZ,NEV
          IF((YMAX1.LT.ZERO).OR.(YMAX2.LT.ZERO)) THEN
            WRITE(6,*) ' PHOINP:ERROR:Y RANGE FOR PHOTONS NOT SET'
          ELSE
            CALL GGHIOG(NEV,EE,NA,NZ)
            KEVENT = 0
          ENDIF
        ELSE IF(CNAME.EQ.'GH-HION-F ') THEN
          READ(NUMBER,*) EE,NA,NZ,NEV
          WRITE(6,*) 'GH-HION-F ',EE,NA,NZ,NEV
          IF((YMAX1.LT.ZERO).OR.(YMAX2.LT.ZERO)) THEN
            WRITE(6,*) ' PHOINP:ERROR:Y RANGE FOR PHOTONS NOT SET'
          ELSE
            CALL GHHIOF(NEV,EE,NA,NZ)
            KEVENT = 0
          ENDIF
C
C  sampling of photoproduction events e+e-, backscattered laser
        ELSE IF(CNAME.EQ.'BLASER    ') THEN
          READ(NUMBER,*) EE1,EE2,NEV
          WRITE(6,*) 'BLASER    ',EE1,EE2,NEV
          CALL GGBLSR(NEV,EE1,EE2)
          KEVENT = 0
C
C  sampling of photoproduction events beamstrahlung
        ELSE IF(CNAME.EQ.'BEAMST    ') THEN
          READ(NUMBER,*) EE1,YPSI,SIGX,SIGY,SIGZ,AEB,NEV
          WRITE(6,*) 'BEAMST    ',EE1,YPSI,SIGX,SIGY,SIGZ,AEB,NEV
          IF(YMAX1.LT.ZERO) THEN
            WRITE(6,*) ' PHOINP:ERROR:ELECTRON TAGGER 1 NOT SET'
          ELSE
            CALL GGBEAM(NEV,EE1,YPSI,SIGX,SIGY,SIGZ,AEB)
            KEVENT = 0
          ENDIF
C
C  fixed-energy events in LAB system of particle 2
        ELSE IF(CNAME.EQ.'EVENT-LAB ') THEN
          READ(NUMBER,*) PLAB,NEV
          WRITE(6,*) 'EVENT-LAB ',PLAB,NEV
          CALL POFLAB(PLAB,NEV)
          KEVENT = 0
C
C  fixed-energy events in CM system
        ELSE IF(CNAME.EQ.'EVENT-CMS ') THEN
          READ(NUMBER,*) EE,NEV
          WRITE(6,*) 'EVENT-CMS ',EE,NEV
          CALL POFCMS(EE,NEV)
          KEVENT = 0
C
C  calculate table DSIG/DT
        ELSE IF(CNAME.EQ.'DSIGDT    ') THEN
          READ(NUMBER,*) EE,TMIN,TMAX,NSTEP
          WRITE(6,*) 'DSIGDT    ',EE,' ',TMIN,' ',TMAX,' ',NSTEP
          CALL FITPAR(1)
          IF(NSTEP.GT.NTABM) THEN
            WRITE(6,*) ' DSIGDT: too many table entries desired'
          ELSE
            DELTAT=(TMAX-TMIN)/DBLE(NSTEP-1)
            DO 105 K=1,NSTEP
              XTA(1,K)=TMIN+DELTAT*DBLE(K-1)
 105        CONTINUE
            CALL DSIGDT(EE,XTA,NSTEP)
            WRITE(6,'(A)') ' TABLE:  -T (GeV**2)  DSIG/DT (mub/GeV**2)'
            WRITE(6,'(A)') ' *****************************************'
            DO 106 K=1,NSTEP
              WRITE(6,'(5X,6E15.3)') (XTA(I,K),I=1,6)
 106        CONTINUE
          ENDIF
C
C***  unknown data card:
        ELSE
          WRITE(6,*) 'PHOINP:WARNING:UNKNOWN DATA CARD: ',CNAME,NUMBER
        ENDIF
      GOTO 1200
 1300 CONTINUE
      WRITE(6,*) ' RETURN'
      END
