C
C
      SUBROUTINE POFCMS(EE,NEV)
C**********************************************************************
C
C     interface to call PHOJET (fixed energy run) with
C     CMS kinematics
C
C     equivalen photon approximation to get photon flux
C
C     input:     NEV     number of events to generate
C                EE      sqrt(s)
C
C     note: particle types have to be specified before 
C           with SETPAR
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER(ONE   = 1.D0,
     &          ZERO  = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
      COMMON /HAGAUP/ NGAUP1,NGAUP2,NGAUET,NGAUIN,NGAUSO
C
      DIMENSION P1(4),P2(4)
C
      ECM = EE
C  remnant initialization (only needed for DTUNUC)
      ISAVP1 = IFPAP(1)
      ISAVB1 = IFPAB(1)
      IF(IFPAP(1).EQ.777) THEN
        IFPAP(1) = IDEQP(1)
        IFPAB(1) = IDEQB(1)
      ENDIF
      ISAVP2 = IFPAP(2)
      ISAVB2 = IFPAB(2)
      IF(IFPAP(2).EQ.888) THEN
        IFPAP(2) = IDEQP(2)
        IFPAB(2) = IDEQB(2)
      ENDIF
C  get momenta in CMS system
      PMASS1 = POPAMA(IFPAB(1),0)-SQRT(PVIRT(1))
      PMASS2 = POPAMA(IFPAB(2),0)-SQRT(PVIRT(2))
      CALL PECMS(1,PMASS1,PMASS2,ECM,PCM,EE)
      P1(1) = ZERO
      P1(2) = ZERO
      P1(3) = PCM
      P1(4) = EE
      P2(1) = ZERO
      P2(2) = ZERO
      P2(3) = -PCM
      P2(4) = ECM-EE
      CALL EVENT(-1,P1,P2,SIGMAX,IREJ)
      IFPAP(1) = ISAVP1
      IFPAB(1) = ISAVB1
      IFPAP(2) = ISAVP2
      IFPAB(2) = ISAVB2
      ITRY = 0
      CALL POHIST(-1,SIGMAX)
      CALL POLUHI(-1,SIGMAX)
C  main generation loop
      DO 50 I=1,NEV
 55     CONTINUE
        ITRY = ITRY+1
        CALL EVENT(1,P1,P2,SIGCUR,IREJ)
        IF(IREJ.NE.0) GOTO 55
        CALL POHIST(1,ONE)
        CALL POLUHI(1,ONE)
 50   CONTINUE
      IF(NEV.GT.0) THEN
        SIGMAX = SIGMAX*DBLE(NEV)/DBLE(ITRY)
        WRITE(6,'(//1X,A,/1X,A,1PE12.3,A,/1X,A)')
     &  '=========================================================',
     &  ' *****   simulated cross section: ',SIGMAX,' mb  *****',
     &  '========================================================='
        CALL EVENT(-2,P1,P2,SIGCUR,IREJ)
        CALL POHIST(-2,SIGMAX)
        CALL POLUHI(-2,SIGMAX)
      ELSE
        WRITE(6,'(1X,A,I5)') 'COLLID:WARNING:no events simulated',NEV
      ENDIF
      END
