C
C
      SUBROUTINE POMEMA(I,J,AMPS,AMPS2,AMVE,AMVE2,IPS,IVE)
C**********************************************************************
C
C     determine meson masses corresponding to the input flavours
C
C     input: I,J     1,2,3,4 -->  u/d/s/c
C                    7,8,9,10     au/ad/as/ac
C                               (other flavours are not supported)
C
C     output: AMPS     pseudo scalar meson mass
C             AMPS2    next possible two particle configuration
C                      (two pseudo scalar  mesons)
C             AMVE     vector meson mass
C             AMVE2    next possible two particle configuration
C                      (two vector mesons)
C             IPS,IVE  meson numbers in BAMJET
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
      COMMON/INPDAT/IMPS(6,6),IMVE(6,6),IB08(6,21),IB10(6,21),
     *IA08(6,21),IA10(6,21),A1,B1,B2,B3,LT,LB,ISU,IYQ,BET,AS,B8,AME,DIQ
C
      IF(I.GT.6) THEN
        II = I -6
        JJ = J
      ELSE IF(J.GT.6) THEN
        II = J -6
        JJ = I
      ELSE
        WRITE(6,'(/1X,A,2I4)')
     &    'POMEMA:ERROR: INCONSISTENT QUARK FLAVOURS ',I,J
        CALL POABRT
      ENDIF
C
C  find index
      IPS = IMPS(II,JJ)
      IVE = IMVE(II,JJ)
C  masses
      AMPS = AM(IPS)
      AMVE = AM(IVE)
C
C  find next possible two particle configuration with lowest mass
C  (insert q qbar system)
      AM2P = 1000.D0
      AM2V = 1000.D0
      DO 100 K=1,4
        AM2P = MIN(AM2P,AM(IMPS(II,K))+AM(IMPS(K,JJ)))
        AM2V = MIN(AM2V,AM(IMVE(II,K))+AM(IMVE(K,JJ)))
 100  CONTINUE
C  add phase space
      AMPS2 = AM2P*1.5D0
      AMVE2 = AM2V*1.1D0
      END
