C
C
      SUBROUTINE POPREV(NPART)
C**********************************************************************
C
C     print all information of event generation and history
C
C     input:        NPART  -1   minimal output: process IDs
C                           0   additional output of /HEPEVS/
C                          >0   additional output of /STRING/
C                          >1   additional output of /HEPEVT/
C                               (call LULIST(1))
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO = 0.D0)
C  global energy
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      CHARACTER*8 PANAME
C
      IF(NPART.GE.0) WRITE(6,'(/)')
      WRITE(6,'(1X,A,E12.3)')
     &  'POPREV:DEBUG:EVENT CHARACTERISTICS,CM-ENERGY',ECM
      CALL SETPAR(-2,IH,NPART,ZERO)
      WRITE(6,'(6X,A,A,/1X,I10,10I6)')
     &  'EV-CALL,ISPOM,IHPOM,ISREG,IHDIR,KSTRG,',
     &  'KHTRG,KSLOO,KHLOO,KSDPO,KHDPO',
     &  KEVENT,KSPOM,KHPOM,KSREG,KHDIR,KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,
     &  KHDPO
      WRITE(6,'(6X,A,I4,4I3)')
     &  'PROCESS-ID,IDNODF,IDIFF1,IDIFF2,IDDPOM',IPROCE,IDNODF,IDIFR1,
     &  IDIFR2,IDDPOM
C
      IF(NPART.LT.0) RETURN
C
      IF(NPART.GE.1) CALL POPRST
C
      WRITE(6,'(2(/1X,A))') 'COMMON HEPEVS',
     &                      '============='
      ICHAS  = 0
      IBARFS = 0
      WRITE(6,'(/1X,A,A,/,1X,A,A)')
     &  '   NO  IST  PDGID   NAME   MO-1 MO-2 DA-1 DA-2  CHA  BAR',
     &  '  IH1  IH2  CO1  CO2',
     &  '--------------------------------------------------------',
     &  '--------------------'
      DO 20 IH=1,NHEP
        CH = DBLE(IPOCH3(IH,2)/3.D0)
        BA = DBLE(IPOBA3(IH,2)/3.D0)
        WRITE(6,'(1X,2I5,I7,1X,A8,4I5,2F5.1,2I5,2I5)')
     &    IH,ISTHEP(IH),IDHEP(IH),PANAME(IH,2),
     &    JMOHEP(1,IH),JMOHEP(2,IH),JDAHEP(1,IH),JDAHEP(2,IH),
     &    CH,BA,IPHIST(1,IH),IPHIST(2,IH),
     &    ICOLOR(1,IH),ICOLOR(2,IH)
        IF(ABS(ISTHEP(IH)).EQ.1) THEN
          ICHAS  = ICHAS  + IPOCH3(IH,2)
          IBARFS = IBARFS + IPOBA3(IH,2)
        ENDIF
   20 CONTINUE
      WRITE(6,'(1X,2(A,I6))') '     SUMMED CHARGE:',ICHAS/3,
     &                        '     SUMMED BARYON:',IBARFS/3
C
      WRITE(6,7)
      PXS    = ZERO
      PYS    = ZERO
      PZS    = ZERO
      P0S    = ZERO
      DO 30 IN=1,NHEP
        IF(     (ABS(PHEP(3,IN)).LT.99999.D0)
     &     .AND.(PHEP(4,IN).LT.99999.D0)) THEN
          WRITE(6,8) IN,ISTHEP(IN),IMPART(IN),PANAME(IN,2),
     &      (PHEP(J,IN),J=1,5),SQRT(PHEP(1,IN)**2+PHEP(2,IN)**2)
        ELSE
          WRITE(6,11) IN,ISTHEP(IN),IMPART(IN),PANAME(IN,2),
     &      (PHEP(J,IN),J=1,5),SQRT(PHEP(1,IN)**2+PHEP(2,IN)**2)
        ENDIF
        IF(ABS(ISTHEP(IN)).EQ.1) THEN
          PXS = PXS + PHEP(1,IN)
          PYS = PYS + PHEP(2,IN)
          PZS = PZS + PHEP(3,IN)
          P0S = P0S + PHEP(4,IN)
        ENDIF
   30 CONTINUE
      AMFS = P0S**2-PXS**2-PYS**2-PZS**2
      AMFS = SIGN(SQRT(ABS(AMFS)),AMFS)
      IF(P0S.LT.99999.D0) THEN
        WRITE(6,10) ' SUM:   ',PXS,PYS,PZS,P0S,AMFS
      ELSE
        WRITE(6,12) ' SUM:   ',PXS,PYS,PZS,P0S,AMFS
      ENDIF
      WRITE(6,'(//)')
C
    5 FORMAT(2X,8H NUMBER ,8H STATUS ,8H IDENT. ,
     &  8H 1.MOTH.,8H 2.MOTH.,8H 1.DAUG.,8H L.DAUG.,
     &  8H CHARGE ,8H BARYON ,/)
    6 FORMAT(7I8,2F8.3)
    7 FORMAT(/,2X,' NR STAT CODE  NAME  X-MOMENTA',
     &  ' Y-MOMENTA Z-MOMENTA  ENERGY    MASS     PT',/,
     &         2X,'-------------------------------',
     &  '--------------------------------------------')
    8 FORMAT(I5,I4,I5,2X,A8,2F8.3,3F10.3,F8.3)
    9 FORMAT(I10,14X,5F10.3)
   10 FORMAT(15X,A8,1X,2F8.3,3F10.3)
   11 FORMAT(I5,I4,I5,2X,A8,2F8.2,2F10.1,F10.3,F8.3)
   12 FORMAT(15X,A8,1X,2F8.2,2F10.1,F10.3)
C
      IF(NPART.GE.2) CALL LULIST(1)
      END
