C
C
      SUBROUTINE SAMASS(IFLA,RMASS)
C**********************************************************************
C
C     resonance mass sampling of quasi elastic processes
C
C     input:   IFLA       PDG number of particle
C              IFLA   -1  initialization
C              IFLA   -2  output of statistics
C
C     output:  RMASS      particle mass (in GeV)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(EPS  = 1.D-10,
     &          IONE = 1,
     &          ONE  = 1.D0,
     &          ZERO = 0.D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /QEVECM/ VMAS(4),GAMM(4),RMIN(4),RMAX(4),VMSL(4),VMFA(4),
     &                TMIN(4),TMAX(4)
C
      CHARACTER*79  TITLE
      DIMENSION     IHIS(4)
      PARAMETER(NTABM=50)
      DIMENSION XMA(4,NTABM),XMC(4,NTABM),RMA(4,NTABM)
      DIMENSION SUM(4),ICALL(4)
      DIMENSION XLIMB(2)
C
C*****************************************************************
C  initialization of tables
      IF(IFLA.EQ.-1) THEN
C
        NSTEP = NTABM
        DO 102 I=1,4
          ICALL(I) = 0
          IHIS(I)  = 0
          IF(IDEB(35).GE.1)
     &      CALL NEWHIS(RMIN(I),RMAX(I),ZERO,XLIMB,30,IHIS(I))
          DELTAM=(RMAX(I)-RMIN(I))/DBLE(NSTEP-1)
          DO 105 K=1,NSTEP
            RMA(I,K)=RMIN(I)+DELTAM*DBLE(K-1)
 105      CONTINUE
 102    CONTINUE
C  calculate table of dsig/dm
        CALL DSIGDM(RMA,XMA,NSTEP)
C  output of table
        IF(IDEB(35).GE.1) THEN
          WRITE(6,'(/5X,A)') 'TABLE:   MASS (GeV)  DSIG/DM (mub/GeV)'
          WRITE(6,'(1X,A,/1X,A)')
     &      '  (M,  RHO,     M,  OMEGA,      M,   PHI,    M,  PI+PI-)',
     &      ' -------------------------------------------------------'
          DO 106 K=1,NSTEP
            WRITE(6,'(1X,8E12.3)') RMA(1,K),XMA(1,K),
     &        RMA(2,K),XMA(2,K),RMA(3,K),XMA(3,K),RMA(4,K),XMA(4,K)
 106      CONTINUE
        ENDIF
C  make second table for sampling
        DO 109 I=1,4
          SUM(I) = ZERO
          DO 108 K=2,NSTEP
            SUM(I) = SUM(I) + (XMA(I,K-1)+XMA(I,K))/2.D0
            XMC(I,K) = SUM(I)
 108      CONTINUE
 109    CONTINUE
C  normalization
        DO 118 K=1,NSTEP
          DO 119 I=1,4
            XMC(I,K) = XMC(I,K)/XMC(I,NSTEP)
 119      CONTINUE
 118    CONTINUE
        IF(IDEB(35).GE.10) THEN
          WRITE(6,'(/5X,A)') 'DSIGDM:DEBUG:NORMALIZED SUMMED TABLE:'
          WRITE(6,'(1X,A,/1X,A)')
     &      '  (M,  RHO,     M,  OMEGA,      M,   PHI,    M,  PI+PI-)',
     &      ' -------------------------------------------------------'
          DO 120 K=1,NSTEP
            WRITE(6,'(1X,8E12.3)') RMA(1,K),XMC(1,K),
     &        RMA(2,K),XMC(2,K),RMA(3,K),XMC(3,K),RMA(4,K),XMC(4,K)
 120      CONTINUE
        ENDIF
C
C**************************************************
C  output of statistics
      ELSE IF(IFLA.EQ.-2) THEN
        WRITE(6,'(2(/1X,A))') 'SAMASS:DEBUG:STATISTICS',
     &                        '========================'
        WRITE(6,'(4(/8X,A,I10))') 'RHO:   ',ICALL(1),
     &    'OMEGA: ',ICALL(2),'PHI:   ',ICALL(3),'PI+PI-:',ICALL(4)
        IF(IHIS(1).NE.0) THEN
          TITLE='SAMASS: RHO0 MASS DISTRIBUTION (QUASI-ELASTIC)'
          CALL OUTHIS(IHIS(1),0,TITLE,ONE,0)
        ENDIF
        IF(IHIS(2).NE.0) THEN
          TITLE='SAMASS: OMEGA(768) MASS DISTRIBUTION (QUASI-ELASTIC)'
          CALL OUTHIS(IHIS(2),0,TITLE,ONE,0)
        ENDIF
        IF(IHIS(3).NE.0) THEN
          TITLE='SAMASS: PHI MASS DISTRIBUTION (QUASI-ELASTIC)'
          CALL OUTHIS(IHIS(3),0,TITLE,ONE,0)
        ENDIF
        IF(IHIS(4).NE.0) THEN
          TITLE='SAMASS: PI+/PI- MASS DISTRIBUTION (BACKGROUND)'
          CALL OUTHIS(IHIS(4),0,TITLE,ONE,0)
        ENDIF
C
C********************************************************
C  sampling of RMASS
      ELSE
        IF(IFLA.EQ.113) THEN
          KP = 1
        ELSE IF(IFLA.EQ.223) THEN
          KP = 2
        ELSE IF(IFLA.EQ.333) THEN
          KP = 3
        ELSE IF(IFLA.EQ.6666) THEN
          KP = 4
        ELSE
          RMASS = POPAMA(IFLA,1)
          IF(IDEB(35).GE.20) WRITE(6,'(1X,A,I7,E12.3)')
     &      'SAMASS:DEBUG:IFLA,MASS',IFLA,RMASS
          RETURN
        ENDIF
        XI = RNDM(RMASS) + EPS
C  binary search
        IF((XMC(KP,1).LE.XI).AND.(XMC(KP,NSTEP).GE.XI)) THEN
          KMIN=1
          KMAX=NSTEP
 300      CONTINUE
          IF((KMAX-KMIN).EQ.IONE) GOTO 400
          KK=(KMAX+KMIN)/2
          IF(XI.LE.XMC(KP,KK)) THEN
            KMAX=KK
          ELSE
            KMIN=KK
          ENDIF
          GOTO 300
 400      CONTINUE
        ELSE
          WRITE(6,'(1X,A)') 'SAMASS:ERROR:XI OUT OF RANGE'
          WRITE(6,'(5X,A,I7,I6,E12.4)') 'EVENT,IFLA,XI',
     &      KEVENT,IFLA,XI
          CALL POABRT
        ENDIF
C  fine interpolation
        RMASS = RMA(KP,KMIN)+
     &          (RMA(KP,KMAX)-RMA(KP,KMIN))/
     &          (XMC(KP,KMAX)-XMC(KP,KMIN))
     &          *(XI-XMC(KP,KMIN))
        IF(IDEB(35).GE.20) THEN
          IF(IDEB(35).GE.25) WRITE(6,'(1X,A,3E15.3)')
     &      'SAMASS:DEBUG:MLEFT,MRIGHT,RMASS',
     &      RMA(KP,KMIN),RMA(KP,KMAX),RMASS
          WRITE(6,'(1X,A,I7,E12.3)') 'SAMASS:DEBUG:IFLA,MASS',
     &      IFLA,RMASS
        ENDIF
C  histogramming
        ICALL(KP) = ICALL(KP)+1
        IF(IHIS(KP).NE.0) THEN
          CALL FILHIS(RMASS,ONE,IHIS(KP))
          CALL ADDHIS(IHIS(KP))
        ENDIF
      ENDIF
      END
